#!/usr/bin/env python
# coding: utf-8

# In[ ]:


# >>>> load module
import pandas as pd
import numpy as np
import netCDF4
# from netCDF4 import Dataset
import matplotlib.pyplot as plt
import scipy.stats as ss
from scipy import optimize
from scipy import stats
import statsmodels.api as sm
#import warnings; warnings.simplefilter('ignore')
import math
pyID='06a'

# -----a_matrix------
def a_matrix():
    a_ma = np.zeros([nx,nx])
    for j in range(nx):
        a_ma[j,j]=-1.0
        
    #----default version : fixed CUE-------     
    a_ma[2,0]=0.5
    a_ma[2,6]=0.5
    a_ma[2,1]=0.25
    a_ma[3,1]=0.7
    a_ma[3,6]=0.7
    a_ma[3,0]=0.35
    a_out=a_ma
    return a_out
#--------kk_matrix------
def kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt):
    xtv=100.0
    kk_out=np.zeros(nx)
    
    iabove=1
    ibelow=2
    imetabolic=1
    istructural=2
    
    
    tvref = math.sqrt(fnpp/xtv)
    tvref = max(0.6,min(1.3,tvref))# 0.8-1.2 based on Wieder et al., 2015
    tvr = 0.00052 *tvref * math.exp(0.3*fmetave)*dt# *x(4)
    tvk = 0.00024 *tvref * math.exp(0.1*fmetave)*dt#  *x(4)
    kk_out[2]=tvr
    kk_out[3]=tvk
    return kk_out    

#------- modelx_control--------
def modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    soilden=2.65 # g cm^-3 soil particle density
    ################ SOIL MOISTURE FUNCTION IN ORCHIDEE ############
    moist_coeff1=1.1
    moist_coeff2=2.4
    moist_coeff3=0.29
    moistcont_min=0.25
    #moistfunc_result=-moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in - moist_coeff3
    moistfunc_result=moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in + moist_coeff3
    control_moist=max(moistcont_min, min(1,moistfunc_result))  #ORCHIDEE
    ##############################################################
    nx=7
    fm=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    fs=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    kor=4.0 # ZHC 6.0 --> 4.0
    kok=4.0 # ZHC 6.0 --> 4.0
    Q1=kor
    Q2=kok

    xvlit= 1.0 # 10.587669
    xvsoc= 1.0  # 23.601484
    xwlit= 1.0  # 2.266886
    xwsoc= 1.0  # 16.683772 
    xklit= 1.0  # 28.889871
    xksoc= 1.0  # 38.088382
    xjlit= 1.0  # 7.25338
    xjsoc= 1.0 # 52.29386
    #xav=x[0]
    #xak=x[1]
    #xdesorp= x[2] #*sum(cpool(5))/100% /(sum(cpool(5:7))/100)%%%% ZHC % 5.513930
    #fbs=math.exp(x[4]*bs)


    desorp = xdesorp * (1.5e-5) * math.exp(-1.5*clay)*dt #(1-exp(-x(4)*cpool(5))) % 0.021570
    # ********** Vmaxt **********
    sv = 0.063
    av = xav*8.0e-6 
    bv = 5.47 #ZHC: xav*1.25e-8 ---> xav*8.0e-6
    xv1=10.0 
    xv2=2.0 
    xv3=10.0 # xv1=10.0; xv2=2.0; xv3=10.0;
    xw1=3.0 
    xw2=3.0 
    xw3=2.0   # xw1=3.0; xw2=3.0; xw3=2.0;
    vmax = av * math.exp(sv*tem + bv) * dt*  control_moist
    V1 =  xv1 * vmax*xvlit # 10 * vmax 
    V2 =  xv2 * vmax*xvlit # 2 * vmax
    V3 =  xv3 * vmax*xvsoc # 10 * vmax 
    W1 =  xw1 * vmax*xwlit # 3 * vmax 
    W2 =  xw2 * vmax*xwlit # 3 * vmax 
    W3 =  xw3 * vmax*xwsoc # 2 * vmax 

    # ********** Kmt **********
    sk =0.02
    ak = xak*10.0 
    bk = 3.19 # ZHC: ak = 0.015625 ---> ak = 10
    xk1 =8.0 
    xk2 = 2.0
    xk3 = 4.0      # xk1 =8.0; xk2 = 2.0; xk3 = 4.0;
    xj1=2.0 
    xj2=4.0 
    xj3 = 6.0         # xj1=2.0; xj2=4.0; xj3 = 6.0;
    xkclay = 1.0/math.exp(-2.0*math.sqrt(clay))   # ZHC: 3.0/exp(-2.0*sqrt(clay)) --->1.0/exp(-2.0*sqrt(clay))
    sk=0.017
    km =  ak*math.exp(sk*tem+bk)*control_moist
    K1 =  xklit*km/xk1        # km/8.0;
    K3 =  xksoc*km*xkclay/xk3  # km*(1-4)/4;
    J1 =  xjlit*km/xj1        # km/2.0
    J3 =  xjsoc*km*xkclay/xj3  # km/*(1-4)/6;
    #
    sk=0.027
    km = ak*math.exp(sk*tem+bk)*control_moist
    K2 =  xklit*km/xk2         # km/2.0
    J2 =  xjlit*km/xj2         # km/4.0

    # **** Changes in C pools
    # dmbc3=kk_ma(3)*(cpool(3)) # turnover of MBC3;
    # dmbc4=kk_ma(4)*(cpool(4)) # turnover of MBC4;
    dmbc3=kk_ma[2]*(cpool[2]**beta) # turnover of MBC3; .^x(6) % 1.140941
    dmbc4=kk_ma[3]*(cpool[3]**beta) # turnover of MBC4; .^x(6) % 1.140941
    #--------------sorption functin--------------
    # from Wang et al., 2013, Mayes et al., 2012
    #kdes=0.001
    #kba=0.0006
    kdes=desorp
    kads=kdes*kba
    #c1=0.595 #0.297
    #c2=2.279 #3.355
    Qmax=10**(c1*np.log10(clay*100)+c2)*rho_b/1000

    y=np.zeros(nx)
    y[0] = litinpc[0]*(1.0-fm)-cpool[0] * (V1 * cpool[2]/(K1 + cpool[0])+W1*cpool[3]/(J1+cpool[0]))
    y[1] = litinpc[1]*(1.0-fs) -cpool[1]*(V2*cpool[2]/(K2+cpool[1])+W2*cpool[3]/(J2+cpool[1]))
    y[2] = a_ma[2,0]*V1*cpool[0]*cpool[2]/(K1+cpool[0])+ a_ma[2,1]*V2*cpool[1]*cpool[2]/(K2+cpool[1])+ a_ma[2,6]*V3*cpool[6]*cpool[2]/(K3+cpool[6])-dmbc3     
    y[3] = a_ma[3,0]*W1*cpool[0]*cpool[3]/(J1+cpool[0])+ a_ma[3,1]*W2*cpool[1]*cpool[3]/(J2+cpool[1])+ a_ma[3,6]*W3*cpool[6]*cpool[3]/(J3+cpool[6])-dmbc4
    y[4] = litinpc[0]*fm+fr2p*dmbc3+fk2p*dmbc4 + kads*(1-cpool[4]/Qmax)*cpool[6]- desorp*cpool[4]
    y[5] = litinpc[1]*fs+fr2c*dmbc3+fk2c*dmbc4- V2*cpool[5]*cpool[2]/(Q1*K2+cpool[5]) - W2*cpool[5]*cpool[3]/(Q2*J2+cpool[5])
    y[6] = fr2a*dmbc3+fk2a*dmbc4+ desorp*cpool[4]+ V2*cpool[5]*cpool[2]/(Q1*K2+cpool[5])+ W2*cpool[5]*cpool[3]/(Q2*J2+cpool[5])- V3*cpool[6]*cpool[2]/(K3+cpool[6]) - W3*cpool[6]*cpool[3]/(J3+cpool[6]) -kads*(1-cpool[4]/Qmax)*cpool[6]   
    return y
#-----modeljacx---------
def modeljacx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    eps = 1.0e-4
    y0=np.zeros(nx)
    y1=np.zeros(nx)
    dydx=np.zeros([nx,nx])
    y0 = modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
    for j in range(nx):
        temp=cpool[j]
        h=eps*abs(temp)
        if h<=0.0:
            h=eps
        cpool[j]=temp+h
        h=cpool[j]-temp
        y1=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool[j]=temp
        for ipool in range(nx):
            dydx[ipool,j]=(y1[ipool]-y0[ipool])/h
    return dydx 

#------------- luccmp ---------------
def ludcmp(dydx,index):
    nmax=500
    tiny=1.0e-20
    d=1.0
    vv=np.zeros(nmax)
    #index=np.zeros(nx)
    dydx1=np.zeros([nx,nx])
    indx=np.zeros(nx)
    dum=np.zeros(nx)
    for i in range(nx):
        aamax=0.0
        for j in np.arange(nx):

            if (abs(dydx[i,j])>aamax):
                aamax=abs(dydx[i,j])
        if (aamax==0.0):
            print('singular matrix in ludcmp')
            dydx1[:,:]=dydx[:,:]
            break
        vv[i]=1./aamax
    for j in range(nx):
        for i in range(j):
            summ=dydx[i,j]
            for k in range(i):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
        aamax=0.
        for i in range(j,nx):  ##1111111
            summ=dydx[i,j]
            for k in range(0,j):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
            dum=vv[i]*abs(summ)
            if (dum>=aamax):
                imax=i
                aamax=dum
        if (j!=imax):
            for k in range(nx):
                dum=dydx[imax,k]
                dydx[imax,k]=dydx[j,k]
                dydx[j,k]=dum
            d=-d
            vv[imax]=vv[j]
        index[j]=imax
        if(dydx[j,j]==0):
            dydx[j,j]=tiny
        if(j!=nx-1):
            dum=1./dydx[j,j]
            for i in np.arange(j+1,nx): 
                dydx[i,j]=dydx[i,j]*dum
        dydx1[:,:]=dydx[:,:]
        indx[:]=index[:]
    return dydx1,indx,d
#-------------- ludksb ----------------
def ludksb(dydx1,indx,p):
    ii=-1
    #p=np.zeros(nx)
    for i in range(nx):
        ll=int(indx[i])
        sumerr=p[ll]
        p[ll]=p[i]
        if (ii!=-1):
            for j in np.arange(ii,i): 
                sumerr=sumerr-dydx1[i,j]*p[j]
        elif (sumerr!= 0):
            ii=i

        p[i]=sumerr
    for i in range(nx-1,-1,-1):   
        sumerr=p[i]
        for j in np.arange(i+1,nx):
            sumerr=sumerr-dydx1[i,j]*p[j]
        p[i]=sumerr/dydx1[i,i]
    return p 

#----------------- mnewt -----------------
def mnewt(ntrial,npm,cpool,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,tem,clay,bs,rho_b,moist_in,dt,tolx,tolf,
          fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    index=np.zeros(nx)
    indx=np.zeros(nx)
    p=np.zeros(nx)
    #p1=np.zeros(nx)
    iflagxy = 0
    for k in range(ntrial):
        y=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        dydx=modeljacx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        errf=0.0
        for i in range(nx):
            dxy = max(abs(min(dydx[i,:])), abs(max(dydx[i,:])))
            if dxy==0.0:
                iflagxy=1
                break
            errf=errf+abs(y[i])

        if (errf<=tolf):
            break
        if (iflagxy==1):
            cpool[:] = 0.0
            break  
        for i in np.arange(nx):
            p[i]=-y[i]
        dydx1,indx,d=ludcmp(dydx,index)

        #---new from HZ1---
        iflagnon=1
        for i in range(nx):
            AA = np.isnan(dydx1[i,:])
            numAA = np.sum(AA) 
            if (numAA==nx):
                print('singular matrix in none value')
                iflagnon=0
                cpool[:] = -999
                break   
        if (iflagnon==0):
            break 
        p1=ludksb(dydx1,indx,p)
        errx=0.0  
        for i in range(nx):
            errx=errx+abs(p1[i])
            cpool[i]=min(max(cpool[i]+p1[i],0.0001),1000)
        if (errx<=tolx):
            break
    return cpool[:]    


# In[ ]:


################ biochar ###################
################ biochar ###################
def a_matrix_bc():
    a_ma = np.zeros([nx,nx])
    for j in range(nx):
        a_ma[j,j]=-1.0
        
    #----default version : fixed CUE-------     
    a_ma[2,0]=0.5
    a_ma[2,6]=0.5
    a_ma[2,1]=0.25
    a_ma[3,1]=0.7
    a_ma[3,6]=0.7
    a_ma[3,0]=0.35
    a_out=a_ma
    return a_out

def kk_matrix_bc(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,dt):
    xtv=100.0
    kk_out=np.zeros(nx)
    
    iabove=1
    ibelow=2
    imetabolic=1
    istructural=2
    
    
    tvref = math.sqrt(fnpp/xtv)
    tvref = max(0.6,min(1.3,tvref))# 0.8-1.2 based on Wieder et al., 2015
    tvr = 0.00052 *tvref * math.exp(0.3*fmetave)*dt# *x(4)
    tvk = 0.00024 *tvref * math.exp(0.1*fmetave)*dt#  *x(4)
    kk_out[2]=tvr
    kk_out[3]=tvk
    return kk_out  


def modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    soilden=2.65 # g cm^-3 soil particle density
    ################ SOIL MOISTURE FUNCTION IN ORCHIDEE ############
    moist_coeff1=1.1
    moist_coeff2=2.4
    moist_coeff3=0.29
    moistcont_min=0.25
    #moistfunc_result=-moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in - moist_coeff3
    moistfunc_result=moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in + moist_coeff3
    control_moist=max(moistcont_min, min(1,moistfunc_result))  #ORCHIDEE
    ##############################################################
    nx=7
    fm=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    fs=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    kor=4.0 # ZHC 6.0 --> 4.0
    kok=4.0 # ZHC 6.0 --> 4.0
    Q1=kor
    Q2=kok

    xvlit= 1.0 # 10.587669
    xvsoc= 1.0  # 23.601484
    xwlit= 1.0  # 2.266886
    xwsoc= 1.0  # 16.683772 
    xklit= 1.0  # 28.889871
    xksoc= 1.0  # 38.088382
    xjlit= 1.0  # 7.25338
    xjsoc= 1.0 # 52.29386
    #xav=x[0]
    #xak=x[1]
    #xdesorp= x[2] #*sum(cpool(5))/100% /(sum(cpool(5:7))/100)%%%% ZHC % 5.513930
    #fbs=math.exp(x[4]*bs)


    desorp = xdesorp * (1.5e-5) * math.exp(-1.5*clay)*dt *(1+fprim*rate_bc)    #(1-exp(-x(4)*cpool(5))) % 0.021570
    # ********** Vmaxt **********
    sv = 0.063
    av = xav*8.0e-6 
    bv = 5.47 #ZHC: xav*1.25e-8 ---> xav*8.0e-6
    xv1=10.0 
    xv2=2.0 
    xv3=10.0 # xv1=10.0; xv2=2.0; xv3=10.0;
    xw1=3.0 
    xw2=3.0 
    xw3=2.0   # xw1=3.0; xw2=3.0; xw3=2.0;
    vmax = av * math.exp(sv*tem + bv) * dt* control_moist*(1+dvmax*rate_bc)
    V1 =  xv1 * vmax*xvlit # 10 * vmax 
    V2 =  xv2 * vmax*xvlit # 2 * vmax
    V3 =  xv3 * vmax*xvsoc # 10 * vmax 
    W1 =  xw1 * vmax*xwlit # 3 * vmax 
    W2 =  xw2 * vmax*xwlit # 3 * vmax 
    W3 =  xw3 * vmax*xwsoc # 2 * vmax 

    # ********** Kmt **********
    sk =0.02
    ak = xak*10.0 
    bk = 3.19 # ZHC: ak = 0.015625 ---> ak = 10
    xk1 =8.0 
    xk2 = 2.0
    xk3 = 4.0      # xk1 =8.0; xk2 = 2.0; xk3 = 4.0;
    xj1=2.0 
    xj2=4.0 
    xj3 = 6.0         # xj1=2.0; xj2=4.0; xj3 = 6.0;
    xkclay = 1.0/math.exp(-2.0*math.sqrt(clay))   # ZHC: 3.0/exp(-2.0*sqrt(clay)) --->1.0/exp(-2.0*sqrt(clay))
    sk=0.017
    km =  ak*math.exp(sk*tem+bk)* control_moist
    K1 =  xklit*km/xk1        # km/8.0;
    K3 =  xksoc*km*xkclay/xk3  # km*(1-4)/4;
    J1 =  xjlit*km/xj1        # km/2.0
    J3 =  xjsoc*km*xkclay/xj3  # km/*(1-4)/6;
    #
    sk=0.027
    km = ak*math.exp(sk*tem+bk)* control_moist
    K2 =  xklit*km/xk2         # km/2.0
    J2 =  xjlit*km/xj2         # km/4.0

    # **** Changes in C pools
    # dmbc3=kk_ma(3)*(cpool(3)) # turnover of MBC3;
    # dmbc4=kk_ma(4)*(cpool(4)) # turnover of MBC4;
    dmbc3=kk_ma[2]*(cpool_bc[2]**beta) # turnover of MBC3; .^x(6) % 1.140941
    dmbc4=kk_ma[3]*(cpool_bc[3]**beta) # turnover of MBC4; .^x(6) % 1.140941
    #------- sorption function ------
    # from Wang et al., 2013, Mayes et al., 2012
    #kdes=0.001
    #kba=0.0006
    kdes=desorp
    kads=kdes*kba
    #c1=0.595 #0.297
    #c2=2.279 #3.355
    Qmax=10**(c1*np.log10(clay*100)+c2)*rho_b/1000
    #------- sorption function ------    
    y=np.zeros(nx)
    y[0] = litinpc[0]*(1.0-fm)-cpool_bc[0] * (V1 * cpool_bc[2]/(K1 + cpool_bc[0])+W1*cpool_bc[3]/(J1+cpool_bc[0]))
    y[1] = litinpc[1]*(1.0-fs) -cpool_bc[1]*(V2*cpool_bc[2]/(K2+cpool_bc[1])+W2*cpool_bc[3]/(J2+cpool_bc[1]))
    y[2] = a_ma[2,0]*V1*cpool_bc[0]*cpool_bc[2]/(K1+cpool_bc[0])+ a_ma[2,1]*V2*cpool_bc[1]*cpool_bc[2]/(K2+cpool_bc[1])+ a_ma[2,6]*V3*cpool_bc[6]*cpool_bc[2]/(K3+cpool_bc[6])-dmbc3     
    y[3] = a_ma[3,0]*W1*cpool_bc[0]*cpool_bc[3]/(J1+cpool_bc[0])+ a_ma[3,1]*W2*cpool_bc[1]*cpool_bc[3]/(J2+cpool_bc[1])+ a_ma[3,6]*W3*cpool_bc[6]*cpool_bc[3]/(J3+cpool_bc[6])-dmbc4
    y[4] = litinpc[0]*fm+fr2p*dmbc3+fk2p*dmbc4+ kads*(1-cpool_bc[4]/Qmax)*cpool_bc[6]  - desorp*cpool_bc[4]
    y[5] = litinpc[1]*fs+fr2c*dmbc3+fk2c*dmbc4- V2*cpool_bc[5]*cpool_bc[2]/(Q1*K2+cpool_bc[5]) - W2*cpool_bc[5]*cpool_bc[3]/(Q2*J2+cpool_bc[5])
    y[6] = fr2a*dmbc3+fk2a*dmbc4+ desorp*cpool_bc[4]+ V2*cpool_bc[5]*cpool_bc[2]/(Q1*K2+cpool_bc[5])+ W2*cpool_bc[5]*cpool_bc[3]/(Q2*J2+cpool_bc[5])- V3*cpool_bc[6]*cpool_bc[2]/(K3+cpool_bc[6]) - W3*cpool_bc[6]*cpool_bc[3]/(J3+cpool_bc[6]) -kads*(1-cpool_bc[4]/Qmax)*cpool_bc[6]   
    return y

def modeljacx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    eps = 1.0e-4
    y0=np.zeros(nx)
    y1=np.zeros(nx)
    dydx=np.zeros([nx,nx])
    y0 = modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
    for j in range(nx):
        temp=cpool_bc[j]
        h=eps*abs(temp)
        if h<=0.0:
            h=eps
        cpool_bc[j]=temp+h
        h=cpool_bc[j]-temp
        y1=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim, dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool_bc[j]=temp
        for ipool in range(nx):
            dydx[ipool,j]=(y1[ipool]-y0[ipool])/h
    return dydx 

def ludcmp_bc(dydx,index):
    nmax=500
    tiny=1.0e-20
    d=1.0
    vv=np.zeros(nmax)
    #index=np.zeros(nx)
    dydx1=np.zeros([nx,nx])
    indx=np.zeros(nx)
    dum=np.zeros(nx)
    for i in range(nx):
        aamax=0.0
        for j in np.arange(nx):

            if (abs(dydx[i,j])>aamax):
                aamax=abs(dydx[i,j])
        if (aamax==0.0):
            print('singular matrix in ludcmp')
            dydx1[:,:]=dydx[:,:]
            break
        vv[i]=1./aamax
    for j in range(nx):
        for i in range(j):
            summ=dydx[i,j]
            for k in range(i):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
        aamax=0.
        for i in range(j,nx):  ##1111111
            summ=dydx[i,j]
            for k in range(0,j):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
            dum=vv[i]*abs(summ)
            if (dum>=aamax):
                imax=i
                aamax=dum
        if (j!=imax):
            for k in range(nx):
                dum=dydx[imax,k]
                dydx[imax,k]=dydx[j,k]
                dydx[j,k]=dum
            d=-d
            vv[imax]=vv[j]
        index[j]=imax
        if(dydx[j,j]==0):
            dydx[j,j]=tiny
        if(j!=nx-1):
            dum=1./dydx[j,j]
            for i in np.arange(j+1,nx): #11111111
                dydx[i,j]=dydx[i,j]*dum
        dydx1[:,:]=dydx[:,:]
        indx[:]=index[:]
    return dydx1,indx,d

def ludksb_bc(dydx1,indx,p):
    ii=-1
    #p=np.zeros(nx)
    for i in range(nx):
        ll=int(indx[i])
        sumerr=p[ll]
        p[ll]=p[i]
        if (ii!=-1):
            for j in np.arange(ii,i): 
                sumerr=sumerr-dydx1[i,j]*p[j]
        elif (sumerr!= 0):
            ii=i

        p[i]=sumerr
    for i in range(nx-1,-1,-1):   #111111
        sumerr=p[i]
        for j in np.arange(i+1,nx):
            sumerr=sumerr-dydx1[i,j]*p[j]
        p[i]=sumerr/dydx1[i,i]
    return p 
#----------------- mnewt -----------------
def mnewt_bc(ntrial,npm,cpool_bc,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,tem,clay,bs,rho_b,moist_in,rate_bc,dt,tolx,tolf,
          fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    index=np.zeros(nx)
    indx=np.zeros(nx)
    p=np.zeros(nx)
    #p1=np.zeros(nx)
    iflagxy = 0
    for k in range(ntrial):
        y=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        dydx=modeljacx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        errf=0.0
        for i in range(nx):
            dxy = max(abs(min(dydx[i,:])), abs(max(dydx[i,:])))
            if dxy==0.0:
                iflagxy=1
                break
            errf=errf+abs(y[i])

        if (errf<=tolf):
            break
        if (iflagxy==1):
            cpool_bc[:] = 0.0
            break  
        for i in np.arange(nx):
            p[i]=-y[i]
        dydx1,indx,d=ludcmp_bc(dydx,index)

        #---new from HZ1---
        iflagnon=1
        for i in range(nx):
            AA = np.isnan(dydx1[i,:])
            numAA = np.sum(AA) 
            if (numAA==nx):
                print('singular matrix in none value')
                iflagnon=0
                cpool_bc[:] = -999
                break   
        if (iflagnon==0):
            break 
        p1=ludksb_bc(dydx1,indx,p)
        errx=0.0  
        for i in range(nx):
            errx=errx+abs(p1[i])
            cpool_bc[i]=min(max(cpool_bc[i]+p1[i],0.0001),1000)
        if (errx<=tolx):
            break
    return cpool_bc[:]


# In[ ]:


# -------calculate steady state SOC from MIMICS_T------
def matrix_fun(xav,xak,xdesorp,beta,kba,c1,c2,obs):
    nx=7
    one_year=365
    one_day=86400
    emax=0.8
    cue_coef1=0.662
    cue_coef2=0.5
    m_fdecomp=296.8
    
    clay = 0.2
    partden=2.65 # soil particle density
    
    lignin_struc_cmatrix = 0.76  # lignin in matrix_nextlitter
    litter_struct_coef = 3. 
    cn_r=[30.,30., 7.4, 13.4, 12., 16., 10.] # C/N ratio for [abo_meta,bel_meta,abo_stru,bel_stru,active,slow,passive]
    cn_rr=7.4
    cn_rk=13.4
    
    
    dt=1 # time step = 1 hour
    nd=365
    ntrial=100
    #npm=len(x) # number of optimized parameters
    npm=3
    nobs=len(obs)
    # soil_weight=1. ;% kg, weight of soil
    tolx=0.0001
    tolf=0.000001
    f=0
    sd1=0
    sdlitt=0
    sdsoc=0

    ng=len(obs)
    nsamp=ng
    kk=np.zeros([ng,nx])
    fmic=np.zeros(ng)
    fphys=np.zeros(ng)
    fchem=np.zeros(ng)
    favail=np.zeros(ng)

    cpool_equlib=np.zeros([nobs,nx])
    cpool_eq=np.zeros(nx)
    CXY=np.zeros([nobs,2])
    ncxy=0
    #
    for ig in range(ng):
        #isam=obs.loc[group(ig),2]
        isam=ig
        #tem=obs.loc[isam,'MAT_WC']  # Celcius degree (℃)
        tem=obs.loc[isam,'MAT'] 
        #swc=obs.loc[isam,'SWC'] # 0-1
        #clay=obs.loc[isam,'CLAY_GSDE_30cm'] # 0-1
        clay=obs.loc[isam,'Clay'] 
        fnpp=obs.loc[isam,'NPP_MODIS']
        #mineral_n = obs.loc[isam,'MineralN(mg N/kg)']*0.001 # mineral N mg/kg --> g/kg
        sdepth=obs.loc[isam,'Sdepth_ini']# # cm
        bulkd=obs.loc[isam,'Con_BD'] # 
        rho_b=obs.loc[isam,'Con_BD'] # 
        moist_in=obs.loc[isam,'SM']
        #socobs=obs.loc[isam,'SOC(g/kg)'] # gC/kg soil, SOC concentration
  
    #----------------------------------
        f_grain=0.45
        dleafc=fnpp*3/10*(1-f_grain)   # g C m^-2 yr^-1
        drootc=fnpp/5   # g C m^-2 yr^-1
        dwoodc=fnpp/2*(1-f_grain)  # g C m^-2 yr^-1
        cnleaf=25#30    # leaf C:N ratio
        cnroot=45  # root C:N ratio
        cnwood=50#30 # wood C:N ratio
        fligleaf=0.12#0.2 # leaf lignin:C
        fligroot=0.4#0.45 # root lignin:C
        fligwood=0.15#0.35 # wood lignin:C

        bs=obs.loc[isam,'BS_GSDE_30cm'] #base saturation

        dleaf=0.1*dleafc/(24*365.0)/sdepth*dt    # mgc/cm3/day/24 %*x(3)
        droot=0.1*drootc/(24*365.0)/sdepth*dt    # mgc/cm3/day/24 %*x(3)
        dwood=0.1*dwoodc/(24*365.0)/sdepth*dt   #mgc/cm3/day/24 %*x(3)
        fmetleaf=max(0.0,1.0*(0.85-0.013*fligleaf*cnleaf))
        fmetroot=max(0.0,1.0*(0.85-0.013*fligroot*cnroot))
        fmetwood=max(0.0,1.0*(0.85-0.013*fligwood*cnwood))
        fmetave = (dleaf*fmetleaf+droot*fmetroot+dwood*fmetwood)/(dleaf + droot + dwood+ 1.0e-10)
        # Fresh litter input at each time step
        litinpc=np.zeros(nx)
        litinpc[0]=fmetleaf*dleaf+fmetwood*dwood+fmetroot*droot
        litinpc[1]=(1-fmetleaf)*dleaf+(1-fmetwood)*dwood+(1.0-fmetroot)*droot
        #
        x6=0.432
        x7=0.098
        x8=10.56
        x9=29.78
        x10=2.61
        fr2p = min(1.0,x6*0.3 * math.exp(1.3*clay))   # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
        fk2p = min(1.0,x7*0.20 * math.exp(0.8*clay))  # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
        fr2c = min(1.0-fr2p, x8*0.10 * math.exp(-x10*fmetave))  # ! 9.0    to invoid a negative value of fr2a ZHC
        fk2c = min(1.0-fk2p, x9*0.30 * math.exp(-x10*fmetave))  # x(2*nsamp+5) ! 9.0    to invoid a negative value of fk2a ZHC
        fr2a = 1.00 - fr2p - fr2c
        fk2a = 1.00 - fk2p - fk2c
        cpool_ini=np.zeros(nx)
        cpool=np.zeros(nx)
        cpool_ini[0:7]=np.array([0.1,0.2,0.05,0.1,0.1,1.0,2.0])   # initial C pool
        cpool[0:7]=cpool_ini[0:7] # C pool

        kk_ma = kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt)
        a_ma = a_matrix()  # Start simulation

        cpool[:]=cpool_ini[:]
        cpool_eq=mnewt(ntrial,npm,cpool,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,tem,clay,bs,rho_b,moist_in,dt,tolx,tolf,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool_equlib[isam,:]=cpool_eq[:]

    return cpool_equlib    


# In[ ]:


# ----------matrix_funs----------------------
# RUN FROM STEADY WITH NORMAL SPIN UP
# RUN CONTROL AND BIOCHAR TREATMENT TASTS
#--------------------------------------------

def matrix_funs(fprim, dvmax,obs,fbest):

    xav= 15.9079
    xak= 13.1022
    xdesorp= 1.59835
    beta= 1.47245
    kba=2.952
    c1= 0.513437
    c2= 3.86153


    nx=7
    one_year=365
    one_day=86400
    emax=0.8
    cue_coef1=0.662
    cue_coef2=0.5
    m_fdecomp=296.8
    
    clay = 0.2
    partden=2.65 # soil particle density
    
    lignin_struc_cmatrix = 0.76  # lignin in matrix_nextlitter
    litter_struct_coef = 3. 
    cn_r=[30.,30., 7.4, 13.4, 12., 16., 10.] # C/N ratio for [abo_meta,bel_meta,abo_stru,bel_stru,active,slow,passive]
    cn_rr=7.4
    cn_rk=13.4
    
    
    dt=1 # time step = 1 hour
    nd=365
    ntrial=100
    #npm=len(x) # number of optimized parameters
    npm=3
    nobs=len(obs)
    # soil_weight=1. ;% kg, weight of soil
    tolx=0.0001
    tolf=0.000001
    f=0
    sd1=0
    sdlitt=0
    sdsoc=0

    ng=len(obs)
    nsamp=ng
    kk=np.zeros([ng,nx])
    fmic=np.zeros(ng)
    fphys=np.zeros(ng)
    fchem=np.zeros(ng)
    favail=np.zeros(ng)

    cpool_equlib=np.zeros([nobs,nx])
    cpool_equlib_bc=np.zeros([nobs,nx])
    
    cpool_eq=np.zeros(nx)
    cpool_eq_bc=np.zeros(nx)
    #
    RR=np.zeros(ng)
    RC=np.zeros(ng)
    AC=np.zeros(ng)
    
    CXY=np.zeros([nobs,2])
    ncxy=0
    #
    for ig in range(ng):
        #isam=obs.loc[group(ig),2]
        isam=ig
        #tem=obs.loc[isam,'MAT_WC']  # Celcius degree (℃)
        tem=obs.loc[isam,'MAT'] 
        #swc=obs.loc[isam,'SWC'] # 0-1
        #clay=obs.loc[isam,'CLAY_GSDE_30cm'] # 0-1
        clay=obs.loc[isam,'Clay'] 
        fnpp=obs.loc[isam,'NPP_MODIS']
        #mineral_n = obs.loc[isam,'MineralN(mg N/kg)']*0.001 # mineral N mg/kg --> g/kg
        sdepth=obs.loc[isam,'Sdepth_ini']# # cm
        bulkd=obs.loc[isam,'Con_BD'] #
        rho_b=obs.loc[isam,'Con_BD'] # 
        bulkd_bc=obs.loc[isam,'BD'] # 
        #socobs=obs.loc[isam,'SOC(g/kg)'] # gC/kg soil, SOC concentration
        landpoint=int(obs.loc[isam,'land_index'])      # used for 6 hr temperature
        # biochar related input
        rate_bc=obs.loc[isam,'Rate_BC']  # t/ha
        bc_c=obs.loc[isam,'BC_C']        # g/kg
        age_bc=obs.loc[isam,'Age_BC']    # yr
        moist_in=obs.loc[isam,'SM']
        #
        tem6hour=Tair[isam]
        npp24hour=npp[isam]

        
        cpool_ini=np.zeros(nx)
        cpool_ini_bc=np.zeros(nx)
        cpool_ini[0:7]=fbest[isam,:]   # initial C pool
        cpool=np.zeros(nx)  # control
        cpool_bc=np.zeros(nx) # biochar
        
        cpool[0:7]=cpool_ini[0:7] # C pool
        # the carbon in biochar is added in equilibrium SOC in MIMICS
        carb_bc=10*rate_bc*bc_c/1000/sdepth   # mg/cm3
        floss=0.02
        fbp=0.6 # 0.5~0.8
        fba=0.2  #0~0.3
        fbc=1-fbp-fba #
        
        carb_bc_p=carb_bc *(1-floss)*fbp
        carb_bc_c=carb_bc *(1-floss)*fbc
        carb_bc_a=carb_bc *(1-floss)*fba
        cpool_ini_bc[0]=cpool_ini[0]
        cpool_ini_bc[1]=cpool_ini[1]
        cpool_ini_bc[2]=cpool_ini[2]
        cpool_ini_bc[3]=cpool_ini[3]
        cpool_ini_bc[4]=cpool_ini[4]+carb_bc_p  # add biochar carbon in SOMp
        cpool_ini_bc[5]=cpool_ini[5]+carb_bc_c  # add biochar carbon in SOMc
        cpool_ini_bc[6]=cpool_ini[6]+carb_bc_a  # add biochar carbon in SOMa
        
        cpool_bc[0:7]=cpool_ini_bc[0:7] # C pool

        cpool[:]=cpool_ini[:]
        cpool_bc[:]=cpool_ini_bc[:]
        
        nyr =age_bc  # if run long-term, nyr=8 yr
        nday = 365
        nhour = 24
        ntime = int(nyr*nday*nhour)
        #out1 = np.zeros([7,nyr,nday,nhour])    
        #out2 = np.zeros([7,nyr,nday,nhour])
        out1 = np.zeros([ntime,7])    
        out2 = np.zeros([ntime,7])   

        segments1 = [i for i in range(1460) for _ in range(6)]*10  # index for reading 6 hr tem input data,max year is 6 year    
        segments2 = [i for i in range(365) for _ in range(24)]*10  # fnpp
        for i in range(ntime):
            m1=segments1[i]
            m2=segments2[i]
            #tem=Tair[m1,landpoint]-273.15    # K->℃
            #fnpp=nppt[m2]
            tem=tem6hour[m1]
            fnpp=npp24hour[m2]
            #----------------------------------
            f_grain=0.45
            dleafc=fnpp*3/10*(1-f_grain)   # g C m^-2 yr^-1
            drootc=fnpp/5   # g C m^-2 yr^-1
            dwoodc=fnpp/2*(1-f_grain)  # g C m^-2 yr^-1
            cnleaf=25#30    # leaf C:N ratio
            cnroot=45  # root C:N ratio
            cnwood=50#30 # wood C:N ratio
            fligleaf=0.12#0.2 # leaf lignin:C
            fligroot=0.4#0.45 # root lignin:C
            fligwood=0.15#0.35 # wood lignin:C

            bs=obs.loc[isam,'BS_GSDE_30cm'] #base saturation  

            dleaf=0.1*dleafc/(24)/sdepth*dt    # mgc/cm3/day %*x(3)
            droot=0.1*drootc/(24)/sdepth*dt    # mgc/cm3/day %*x(3)
            dwood=0.1*dwoodc/(24)/sdepth*dt   #mgc/cm3/day %*x(3)
            fmetleaf=max(0.0,1.0*(0.85-0.013*fligleaf*cnleaf))
            fmetroot=max(0.0,1.0*(0.85-0.013*fligroot*cnroot))
            fmetwood=max(0.0,1.0*(0.85-0.013*fligwood*cnwood))
            fmetave = (dleaf*fmetleaf+droot*fmetroot+dwood*fmetwood)/(dleaf + droot + dwood+ 1.0e-10)
            # Fresh litter input at each time step
            litinpc=np.zeros(nx)
            litinpc[0]=fmetleaf*dleaf+fmetwood*dwood+fmetroot*droot
            litinpc[1]=(1-fmetleaf)*dleaf+(1-fmetwood)*dwood+(1.0-fmetroot)*droot
            #
            x6=0.432
            x7=0.098
            x8=10.56
            x9=29.78
            x10=2.61
            fr2p = min(1.0,x6*0.3 * math.exp(1.3*clay))   # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
            fk2p = min(1.0,x7*0.20 * math.exp(0.8*clay))  # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
            fr2c = min(1.0-fr2p, x8*0.10 * math.exp(-x10*fmetave))  # ! 9.0    to invoid a negative value of fr2a ZHC
            fk2c = min(1.0-fk2p, x9*0.30 * math.exp(-x10*fmetave))  # x(2*nsamp+5) ! 9.0    to invoid a negative value of fk2a ZHC
            fr2a = 1.00 - fr2p - fr2c
            fk2a = 1.00 - fk2p - fk2c
            kk_ma = kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt)
            kk_ma_bc = kk_matrix_bc(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,dt) # add biochar
            a_ma = a_matrix()  # Start simulation
            a_ma_bc = a_matrix_bc()  # Start simulation
        #-------------------------------
            y1=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
            cpool[0]=max(0,cpool[0]+y1[0])
            cpool[1]=max(0,cpool[1]+y1[1])
            cpool[2]=max(0,cpool[2]+y1[2])
            cpool[3]=max(0,cpool[3]+y1[3])
            cpool[4]=max(0,cpool[4]+y1[4])
            cpool[5]=max(0,cpool[5]+y1[5])
            cpool[6]=max(0,cpool[6]+y1[6])
            out1[i,:]=cpool    
            y2=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma_bc,litinpc,kk_ma_bc,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
            cpool_bc[0]=max(0,cpool_bc[0]+y2[0])
            cpool_bc[1]=max(0,cpool_bc[1]+y2[1])
            cpool_bc[2]=max(0,cpool_bc[2]+y2[2])
            cpool_bc[3]=max(0,cpool_bc[3]+y2[3])
            cpool_bc[4]=max(0,cpool_bc[4]+y2[4])
            cpool_bc[5]=max(0,cpool_bc[5]+y2[5])
            cpool_bc[6]=max(0,cpool_bc[6]+y2[6])
            out2[i,:]=cpool_bc  

        cpool_equlib[isam,:]=out1[-1,:]/bulkd 
        cpool_equlib_bc[isam,:]=out2[-1,:]/bulkd_bc 
        cpool_eq[:]=cpool_equlib[isam,:]
        cpool_eq_bc[:]=cpool_equlib_bc[isam,:]

        # target variables        
        AC[isam]=np.sum(cpool_eq_bc[4:7])-np.sum(cpool_eq[4:7]) 
    return AC
######### Run model ##################      
nx=7
#### Read observation data
#obs = pd.read_excel('Biochar.xlsx','TableS1', index_col=None, na_values=['NA']) 
obs = pd.read_excel('biochar_221123.xlsx','TableS1', index_col=None, na_values=['NA'])
#obs=obs[obs['Age_BC']>=6]
#obs=obs[obs.Croptype.isin(['maize'])]       
#obs=obs.groupby(by='LatLon',as_index=False).mean() #
obs = obs.reset_index(drop=True)

# optimized parameter
fprim= -0.0083  #mimics-BCDV
dvmax= 0.008
fbest1=matrix_funs(fprim,dvmax,obs)
print(fbest1) 

SOMC_sim=fbest1
SOMC_obs=obs['SOC']-obs['Con_SOC']#AC

a=np.array([SOMC_obs,SOMC_sim])
np.save('MIMICS-TSMb-biochar4_1_abc_ageyear_gkg_test.npy',a)   #MIMICS-BCDV,short-term
#np.save...


