#!/usr/bin/env python
# coding: utf-8

# In[1]:


# import and load data
#%matplotlib inline
import pandas as pd
import netCDF4
from netCDF4 import Dataset
import numpy as np
import gdal
from osgeo import gdal
#import matplotlib.pyplot as plt
#from mpl_toolkits.basemap import Basemap, cm
##from matplotlib.colors import BoundaryNorm, ColorConverter
from scipy.optimize import fsolve
import matplotlib.pyplot as plt
import scipy.stats as ss
import math
from pylab import *
import os
pyID = '02a'


# # fig1

# In[2]:


## -------------------------*line fit*-------------------------
from scipy import optimize
import numpy as np
from scipy import stats
import statsmodels.api as sm
import math

def f_1(xx,A,B):
    return A*xx + B


## R2
def get_r2_numpy(x, y):
    slope, intercept = np.polyfit(x, y, 1)
    r_squared = 1 - (sum((y - (slope * x + intercept))**2) / ((len(y) - 1) * np.var(y, ddof=1)))
    return r_squared


# In[ ]:


a1=np.load('MIMICS-Def-merge.npy')
a2=np.load('MIMICS-T-merge.npy')
a3=np.load('MIMICS-T-sorption-merge.npy')
a4=np.load('MIMICS-T-ORCHIDEE-merge.npy')
a5=np.load('MIMICS-T-sorption-orchidee-merge.npy')

y=[a1[1],a2[1],a3[1],a5[1]]
x=[a1[0],a2[0],a3[0],a5[0]]


title=['(a) MIMICS-def','(b) MIMICS-T','(c) MIMICS-TS','(d) MIMICS-$\mathregular{TSM_b}$']
#num_params=np.array([7,9,10,10,10])
num_params=np.array([3,4,7,7])
#---plot-------
fig=plt.figure(figsize=(12,8.2),facecolor='white')
plt.subplots_adjust(left=0.1, bottom=0.1, right=0.95, top=0.95, wspace=0.1, hspace=0.15)  
plt.rcParams.update({'font.size': 15})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})
for i in range(4):
    
    ax1 = fig.add_subplot(2,3,i+1)
    ax1.scatter(x[i],y[i], color='#2BBBD8', s=25, edgecolors='k',linewidth=0.5)
    ax1.plot(np.arange(0,60,5),np.arange(0,60,5),ls='--', lw=0.8, c='k')
    ax1.set_title(title[i], weight='bold', loc='left')    
    plt.xlim(0,40)
    plt.ylim(0,40)
    ax1.set_xticks(np.arange(0,50,10))
    ax1.set_yticks(np.arange(0,50,10))
#-----------rmse-------
    A1,B1= optimize.curve_fit(f_1,x[i],y[i])[0]
    print(A1)
    R2=get_r2_numpy(x[i], y[i])
    ndf1=len(y[i])
    error=y[i]-x[i]
    RMSE=math.sqrt(np.sum(error**2)/ndf1)  #4.74105        
#----------------------
    # aic
    def calculate_aic(n, rmse, num_params):
        aic = n * np.log(rmse) + 2 * num_params
        return aic
    #num_params=10#param_def.shape[1]
    aic= calculate_aic(ndf1, RMSE**2, num_params[i])
    #print('AIC: %.3f' % aic)
#------------------------
    if i==3:
        ax1.set_xlabel('Observed SOC concentration (g kg$\mathdefault{^{-1}}$)')
    if i==0:   
        ax1.set_ylabel('Simulated SOC concentration (g kg$\mathdefault{^{-1}}$)',y=0)
    if i!=0 and i!=3:
        ax1.set_yticklabels([])
    if i!=3:
        ax1.set_xticklabels([])
    
    if i<3: 
        fig.text(0.32+i/3.4,0.85,"1:1",size=12)
        #fig.text(0.12+i/3.4,0.88,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f g kg$\mathdefault{^{-1}}$'%(R2,RMSE),size=12)
        fig.text(0.12+i/3.4,0.85,'R$\mathdefault{^{2}}$=%.2f'%(R2),size=13)
        fig.text(0.12+i/3.4,0.82,'N =%.0f'%(len(y[i])),size=13)
        #fig.text(0.12+i/3.4,0.82,'AIC =%.1f'%(aic),size=12)
        fig.text(0.12+i/3.4,0.89,'Y=%.2fX+%.2f'%(A1,B1),size=13)
        xx1=np.arange(1,35,2)
        yy1=A1 *xx1 +B1
        ax1.plot(xx1,yy1,'black',ls='-',lw=1.)
    else:
        fig.text(-0.58+i/3.34,0.4,"1:1",size=12)
        #fig.text(-0.78+i/3.33,0.43,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f g kg$\mathdefault{^{-1}}$'%(R2,RMSE),size=12)
        fig.text(-0.78+i/3.33,0.4,'R$\mathdefault{^{2}}$=%.2f'%(R2),size=13)
        fig.text(-0.78+i/3.33,0.37,'N =%.0f'%(len(y[i])),size=13)
        #fig.text(-0.78+i/3.33,0.37,'AIC =%.1f'%(aic),size=12)
        fig.text(-0.78+i/3.33,0.44,'Y=%.2fX+%.2f'%(A1,B1),size=13)        
        xx1=np.arange(1,35,2)
        yy1=A1 *xx1 +B1
        ax1.plot(xx1,yy1,'black',ls='-',lw=1.)   
#####################

ix, iy, w0, h0 = 0.44, 0.15, 0.21, 0.344
ax5 = fig.add_axes([ix, iy, w0, h0])#, facecolor='none'
#ax5.set_title('(e)', weight='bold', loc='left')
#fig.text(0.545,0.493,'(e)',weight='bold',size=15)
ax5.set_title('(e)', weight='bold', loc='left')    

x5=np.arange(4)
rmse5=np.array([0.38,0.47,0.51,0.52])
p1=ax5.bar(x5,rmse5,color='skyblue',width=0.32) #'#8ac6d1'
ax5.set_ylabel('R$\mathdefault{^{2}}$',color='dodgerblue')
ax5.tick_params(axis='y',colors='dodgerblue')
ax5.set_xticks(x5+0.18)
ax5.set_xticklabels(['MIMICS-def','MIMICS-T','MIMICS-TS','MIMICS-$\mathregular{TSM_b}$'],rotation='45',horizontalalignment='right',size=14)
#plt.ylim(0,0.4)
ax5.set_yticks(np.arange(0,0.8,0.2))

ax6 = ax5.twinx() 
x6=np.arange(4)+0.35
aic=np.array([4.96,4.61,4.45,4.41])
ax6.bar(x6,aic,color='pink',width=0.32) #'#ffb6b9',
ax6.set_ylabel('RMSE (g kg$\mathdefault{^{-1}}$)',color='hotpink')
#ax5.yaxis.tick_left()
ax6.yaxis.set_label_position("right")
ax6.tick_params(axis='y',colors='hotpink')
ax6.set_yticks(np.arange(4,7,1))
plt.ylim(4,6)
fig.savefig('mimics_output/fig%s_1.png'%(pyID),dpi=300)


# In[11]:


#short term
c1=np.load('MIMICS-TSMb-biochar2_abc_ageyear_gkg_test.npy')
c3=np.load('MIMICS-TSMb-biochar3_1_abc_ageyear_gkg_test.npy')
c4=np.load('MIMICS-TSMb-biochar4_1_abc_ageyear_gkg_test.npy')

#long term
a1=np.load('MIMICS-TSMb-biochar2_abc_8yr_gkg_test.npy')
a3=np.load('MIMICS-TSMb-biochar3_1_abc_8yr_gkg_test.npy')
a4=np.load('MIMICS-TSMb-biochar4_1_abc_8yr_gkg_test.npy')

x1=c1[0]
y1=c1[1]
y3=c3[1]
y4=c4[1]

xl1=a1[0]
yl1=a1[1]
yl3=a3[1]
yl4=a4[1]
#---plot-------
print(a1.shape)


fig=plt.figure(figsize=(12,8),facecolor='white')
plt.subplots_adjust(left=0.08, bottom=0.08, right=0.97, top=0.92, wspace=0.2, hspace=0.25)  
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})
 
ax1 = fig.add_subplot(231)
#ax1 = plt.subplot2grid((2, 3), (0, 0))
#ax.errorbar(SOM_obs,SOM_sim,fmt='o', mec='blue', mfc='white',ms=3,ecolor='b',elinewidth=0.6,capthick=0.6,capsize=2,label='Geisseler et al')
ax1.scatter(x1,y1, color='#FF5F5F', s=20, edgecolors='k',linewidth=0.5,label='short',alpha=0.6)
ax1.scatter(xl1,yl1, color='#2BBBD8', s=20, edgecolors='k',linewidth=0.5,label='long',alpha=0.6)
ax1.plot(np.arange(-5,50,1),np.arange(-5,50,1),ls='--', lw=0.8, c='k')
ax1.set_ylabel('Simulated ΔSOC (g kg$\mathdefault{^{-1}}$)')
ax1.set_xlabel('Observed ΔSOC (g kg$\mathdefault{^{-1}}$)')
ax1.set_title('(a) MIMICS-$\mathregular{TSM_b}$', weight='bold', loc='left')
ax1.set_yticks(np.arange(0,50,20))
ax1.set_xticks(np.arange(0,50,20))
plt.xlim(-5,50)
plt.ylim(-5,50)
font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper left',frameon=False,prop=font1)
#ax1.set_xticklabels([])
fig.text(0.28,0.85,"1:1",size=12)
A1,B1= optimize.curve_fit(f_1,x1,y1)[0]
R1_s=get_r2_numpy(x1, y1)
ndf1=a1.shape[1]
error=y1-x1
RMSE1_s=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
print('short,TMSb:',R1_s,RMSE1_s)
fig.text(0.1,0.84,'slope =%.2f'%(A1),size=12,color='#FF5F5F')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)
ax1.plot(xx1,yy1,'#FF5F5F',ls='-',lw=1.)

A1,B1= optimize.curve_fit(f_1,xl1,yl1)[0]
R1_l=get_r2_numpy(xl1, yl1)
ndf1=a1.shape[1]
error=yl1-xl1
RMSE1_l=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
print('long,TMSb:',R1_l,RMSE1_l)
#fig.text(0.13,0.86,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f'%(R2,RMSE),size=12)
fig.text(0.1,0.79,'N =%.0f'%(ndf1),size=12)
fig.text(0.1,0.82,'slope =%.2f'%(A1),size=12,color='#2BBBD8')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)

ax1.plot(xx1,yy1,'#2BBBD8',ls='-',lw=1.)

################################################
ax2 = fig.add_subplot(232)
#ax2 = plt.subplot2grid((2, 3), (0, 1))
#ax2.set_xticklabels([])
ax2.set_xlabel('Observed ΔSOC (g kg$\mathdefault{^{-1}}$)')
ax2.set_yticklabels([])
ax2.scatter(x1,y3, color='#FF5F5F', s=20, edgecolors='k',linewidth=0.5,label='short',alpha=0.6)
ax2.scatter(xl1,yl3, color='#2BBBD8', s=20, edgecolors='k',linewidth=0.5,label='long',alpha=0.6)
ax2.plot(np.arange(-5,50,1),np.arange(-5,50,1),ls='--', lw=0.8, c='k')
ax2.set_title('(b) MIMICS-$\mathregular{BC_{D}}$', weight='bold', loc='left')
ax2.set_yticks(np.arange(0,50,20))
ax2.set_xticks(np.arange(0,50,20))
plt.xlim(-5,50)
plt.ylim(-5,50)
font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper left',frameon=False,prop=font1)
fig.text(0.62,0.85,"1:1",size=12)

A1,B1= optimize.curve_fit(f_1,x1,y3)[0]
R2_s=get_r2_numpy(x1, y3)
ndf1=a1.shape[1]
error=y3-x1
RMSE2_s=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
#fig.text(0.58,0.86,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f'%(R2,RMSE),size=12)
#fig.text(0.58,0.83,'N =%.0f'%(ndf1),size=12)
fig.text(0.43,0.84,'slope =%.2f'%(A1),size=12,color='#FF5F5F')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)
ax2.plot(xx1,yy1,'#FF5F5F',ls='-',lw=1.)

A1,B1= optimize.curve_fit(f_1,xl1,yl3)[0]
R2_l=get_r2_numpy(xl1, yl3)
ndf1=a1.shape[1]
error=yl3-xl1
RMSE2_l=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
#fig.text(0.58,0.86,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f'%(R2,RMSE),size=12)
fig.text(0.43,0.79,'N =%.0f'%(ndf1),size=12)
fig.text(0.43,0.82,'slope =%.2f'%(A1),size=12,color='#2BBBD8')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)
ax2.plot(xx1,yy1,'#2BBBD8',ls='-',lw=1.)
################################################
ax4 = fig.add_subplot(233)

#ax4 = plt.subplot2grid((2, 3), (1, 0))
ax4.set_xlabel('Observed ΔSOC (g kg$\mathdefault{^{-1}}$)',x=0.5)
ax4.scatter(x1,y4, color='#FF5F5F', s=20, edgecolors='k',linewidth=0.5,label='short',alpha=0.6)
ax4.scatter(xl1,yl4, color='#2BBBD8', s=20, edgecolors='k',linewidth=0.5,label='long',alpha=0.6)
ax4.plot(np.arange(-5,50,1),np.arange(-5,50,1),ls='--', lw=0.8, c='k')
ax4.set_title('(c) MIMICS-$\mathregular{BC_{DV}}$', weight='bold', loc='left')
ax4.set_yticklabels([])
ax4.set_yticks(np.arange(0,50,20))
plt.xlim(-5,50)
plt.ylim(-5,50)
font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper left',frameon=False,prop=font1)
fig.text(0.95,0.85,"1:1",size=12)


A1,B1= optimize.curve_fit(f_1,x1,y4)[0]
R3_s=get_r2_numpy(x1, y4)
ndf1=a1.shape[1]
error=y4-x1
RMSE3_s=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
#fig.text(0.13,0.43,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f'%(R2,RMSE),size=12)
#fig.text(0.13,0.4,'N =%.0f'%(ndf1),size=12)
fig.text(0.76,0.84,'slope =%.2f'%(A1),size=12,color='#FF5F5F')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)
ax4.plot(xx1,yy1,'#FF5F5F',ls='-',lw=1.)

A1,B1= optimize.curve_fit(f_1,xl1,yl4)[0]
R3_l=get_r2_numpy(xl1, yl4)
ndf1=a1.shape[1]
error=yl4-xl1
RMSE3_l=math.sqrt(np.sum(error**2)/ndf1)  #4.74105
#fig.text(0.13,0.43,'R$\mathdefault{^{2}}$=%.2f; RMSE=%.2f'%(R2,RMSE),size=12)
fig.text(0.76,0.79,'N =%.0f'%(ndf1),size=12)
fig.text(0.76,0.82,'slope =%.2f'%(A1),size=12,color='#2BBBD8')
xx1=np.arange(-3,45,5)
yy1=A1 *xx1 +B1
print('slope:', A1)
ax4.plot(xx1,yy1,'#2BBBD8',ls='-',lw=1.)
#####################

ax5 = fig.add_subplot(234)
ax5.set_title('(d)', weight='bold', loc='left')
x5=np.arange(3)
rs=np.array([round(R1_s,2),round(R2_s,2),round(R3_s,2)])
rl=np.array([round(R1_l,2),round(R2_l,2),round(R3_l,2)])
p1=ax5.bar(x5+0.05,rs,color='#FF5F5F',width=0.3,label='short',alpha=0.6) #'#8ac6d1'
p2=ax5.bar(x5+0.36,rl,color='#2BBBD8',width=0.3,label='long',alpha=0.6)
plt.bar_label(p1, label_type='edge',size=10)
plt.bar_label(p2, label_type='edge',size=10)
ax5.set_ylabel('R$\mathdefault{^{2}}$',color='k')
ax5.tick_params(axis='y',colors='k')
ax5.set_xticks(x5+0.2)
ax5.set_xticklabels(['MIMICS-$\mathregular{TSM_b}$','MIMICS-$\mathregular{BC_{D}}$','MIMICS-$\mathregular{BC_{DV}}$'],size=11)
#plt.ylim(0,0.4)
ax5.set_yticks(np.arange(0,1.5,0.3))
#font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper center',frameon=False,prop=font1)

ax5 = fig.add_subplot(235)
ax5.set_title('(e)', weight='bold', loc='left')
x5=np.arange(3)
rmses=np.array([round(RMSE1_s,2),round(RMSE2_s,2),round(RMSE3_s,2)])
rmsel=np.array([round(RMSE1_l,2),round(RMSE2_l,2),round(RMSE3_l,2)])

p1=ax5.bar(x5+0.05,rmses,color='#FF5F5F',width=0.3,alpha=0.6,label='short') #'#8ac6d1'
p2=ax5.bar(x5+0.36,rmsel,color='#2BBBD8',width=0.3,alpha=0.6,label='long')
plt.bar_label(p1, label_type='edge',size=10)
plt.bar_label(p2, label_type='edge',size=10)
ax5.set_ylabel('RMSE (g kg$\mathdefault{^{-1}}$)',color='k')
ax5.tick_params(axis='y',colors='k')
ax5.set_xticks(x5+0.2)
ax5.set_xticklabels(['MIMICS-$\mathregular{TSM_b}$','MIMICS-$\mathregular{BC_{D}}$','MIMICS-$\mathregular{BC_{DV}}$'],size=11)
#plt.ylim(0,0.4)
ax5.set_yticks(np.arange(0,8,1))
font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper right',frameon=False,prop=font1)

ax5 = fig.add_subplot(236)
ax5.set_title('(f)', weight='bold', loc='left')
x5=np.arange(3)
rmses=np.array([348.57,350.57,352.57])
rmsel=np.array([462.76,464.76,466.76])

p1=ax5.bar(x5+0.05,rmses,color='#FF5F5F',width=0.3,alpha=0.6,label='short') #'#8ac6d1'
p2=ax5.bar(x5+0.36,rmsel,color='#2BBBD8',width=0.3,alpha=0.6,label='long')
plt.bar_label(p1, label_type='edge',size=10)
plt.bar_label(p2, label_type='edge',size=10)
ax5.set_ylabel('AIC',color='k')
ax5.tick_params(axis='y',colors='k')
ax5.set_xticks(x5+0.2)
ax5.set_xticklabels(['MIMICS-$\mathregular{TSM_b}$','MIMICS-$\mathregular{BC_{D}}$','MIMICS-$\mathregular{BC_{DV}}$'],size=11)
#plt.ylim(0,0.4)
ax5.set_yticks(np.arange(0,700,100))
font1 = {'weight' : 'normal','size'   : 10}
plt.legend(loc='upper right',frameon=False,prop=font1)


fig.tight_layout()
fig.savefig('fig%s_3.png'%(pyID),dpi=300)


# In[171]:



# long term
a1=np.load('MIMICS-TSMb-biochar2_abc_8yr_gkg_test.npy')
a3=np.load('MIMICS-TSMb-biochar3_1_abc_8yr_gkg_test.npy')
a4=np.load('MIMICS-TSMb-biochar4_1_abc_8yr_gkg_test.npy')

# short term
#a1=np.load('MIMICS-TSMb-biochar2_abc_ageyear_gkg_test.npy')
#a3=np.load('MIMICS-TSMb-biochar3_1_abc_ageyear_gkg_test.npy')
#a4=np.load('MIMICS-TSMb-biochar4_1_abc_ageyear_gkg_test.npy')
a5=np.load('MIMICS-BCDV_fba_opt.npy')

err1=a1[1]-a1[0]  # simulated soc-observed soc, MIMICS-Biochar-def
err2=a3[1]-a3[0]  # MIMICS-Biochar-Pd
err3=a4[1]-a4[0]  # MIMICS-Biochar-Pdv
err4=a5[1]-a5[0]
err=pd.DataFrame(np.transpose(np.array([err1,err2,err3,err4])))
err.shape
#err.to_excel('H:/data/input_df/err.xlsx',sheet_name='TableS1',na_rep='NA')


# In[169]:


# hotplot,short

obs1 = pd.read_csv('H:/data/input_df/pcor1.csv') #
obs3 = pd.read_csv('H:/data/input_df/pcor2.csv') #
obs4 = pd.read_csv('H:/data/input_df/pcor3.csv') #
obs5 = pd.read_csv('H:/data/input_df/pcor4.csv') #
pcor=np.array([obs1['V1'][1:],obs3['V1'][1:],obs4['V1'][1:],obs5['V1'][1:]])
print(pcor.shape)
print(pcor)
# add the relation of ACsoc and other input variables
cor0_s=np.array([[-0.09,-0.29,0.08,0.04,-0.01,0.74,0.07,0.06]])
cor0_l=np.array([[-0.06,-0.3,0.05,-0.04,-0.05,0.85,0.2,0.05]])
print(cor0_s.shape)
print(cor0_s)
pcor_tot=np.append(cor0_s,pcor,axis=0)  
print(pcor_tot.shape)
pcor_tot
#--------------hotplot------------------------------------
import seaborn as sns
fig = plt.figure(figsize=(10,5),facecolor='white')
plt.subplots_adjust(left=0.2, bottom=0.2, right=0.95, top=0.9, wspace=0.1, hspace=0.15)  
ax = plt.subplot(111)
p1=sns.heatmap(pcor_tot[:,:-1],vmin=-0.5,vmax=0.5,cmap="coolwarm",annot=True,fmt='.2f',linewidths=.05,ax=ax,cbar=False) 

cb=p1.figure.colorbar(p1.collections[0],shrink=1) #
cb.ax.tick_params(labelsize=11) #
cb.set_ticks(np.arange(-0.5, 0.7, 0.2)) ##
#ax.set_yticks([])

#ax.set_xticks(np.arange(0, nvars_coll))
ax.set_xticklabels(['Clay','BD','SM','MAT','NPP','Rate_BC','Age_BC'],rotation=45,horizontalalignment='right')
#ax.set_yticks(np.arange(0, nvars_coll))
ax.set_yticklabels(['$\mathregular{ΔSOC}$','MIMICS-$\mathregular{TSM_b}$','MIMICS-$\mathregular{BC_{D}}$','MIMICS-$\mathregular{BC_{DV}}$','MIMICS-$\mathregular{BC_{DV*}}$'],rotation=0,horizontalalignment='right')
#cb.set_ticks, cb.set_ticklabels
#cb.outline.set_visible(False) #
cb.set_label('Correlation coefficient')
#ax.set_ylabel('Correlation coefficient')
#ax.yaxis.set_label_position("right")
#plt.setp(label_x, rotation=45, horizontalalignment='right')

fig.text(0.35,0.83,'*',size=20,color='white')
fig.text(0.69,0.83,'*',size=20,color='white')

fig.text(0.265,0.69,'*',size=20,color='white')
fig.text(0.52,0.69,'*',size=20)
#fig.text(0.69,0.69,'*',size=20,color='white')
#fig.text(0.78,0.69,'*',size=20)

fig.text(0.265,0.55,'*',size=20)
fig.text(0.52,0.55,'*',size=20)

fig.text(0.265,0.40,'*',size=20)
fig.text(0.52,0.40,'*',size=20)
fig.text(0.265,0.26,'*',size=20)
#fig.text(0.695,0.33,'*',size=20,color='white')
#plt.setp(label_y, rotation=360, horizontalalignment='right')
plt.show()
fig.savefig('fig%s_pcor_short.png'%(pyID),dpi=300)


# In[208]:


# hotplot,long-term

obs1 = pd.read_csv('H:/data/input_df/pcor1.csv') #
obs3 = pd.read_csv('H:/data/input_df/pcor2.csv') #
obs4 = pd.read_csv('H:/data/input_df/pcor3.csv') #
pcor=np.array([obs1['V1'][1:],obs3['V1'][1:],obs4['V1'][1:]])
print(pcor.shape)
print(pcor)
# add the relation of ACsoc and other input variables
cor0_s=np.array([[-0.09,-0.29,0.08,0.04,-0.01,0.74,0.07,0.06]])
cor0_l=np.array([[-0.06,-0.3,0.05,-0.04,-0.05,0.85,0.2,0.05]])
print(cor0_l.shape)
print(cor0_l)

pcor_tot=np.append(cor0_l,pcor,axis=0) 
print(pcor_tot.shape)
pcor_tot
#-------------------hotplot---------------------
import seaborn as sns
fig = plt.figure(figsize=(10,4),facecolor='white')
plt.subplots_adjust(left=0.2, bottom=0.25, right=0.95, top=0.95, wspace=0.1, hspace=0.15)  

plt.rcParams.update({'font.size': 15})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})
ax = plt.subplot(111)
p1=sns.heatmap(pcor[:,:-1],vmin=-0.5,vmax=0.5,cmap="coolwarm",annot=True,fmt='.2f',linewidths=.05,ax=ax,cbar=False) 

cb=p1.figure.colorbar(p1.collections[0],shrink=1) 
cb.ax.tick_params(labelsize=11) #
cb.set_ticks(np.arange(-0.5, 0.7, 0.2)) #
#ax.set_yticks([])

#ax.set_xticks(np.arange(0, nvars_coll))
ax.set_xticklabels(['Clay','BD','SM','MAT','NPP','Rate_BC','Age_BC'],rotation=45,horizontalalignment='right')
#ax.set_yticks(np.arange(0, nvars_coll))
ax.set_yticklabels(['MIMICS-$\mathregular{TSM_b}$','MIMICS-$\mathregular{BC_{D}}$','MIMICS-$\mathregular{BC_{DV}}$'],rotation=0,horizontalalignment='right')
#cb.set_ticks, cb.set_ticklabels
#cb.outline.set_visible(False) #
cb.set_label('Correlation coefficient')

fig.text(0.265,0.81,'*',size=20,color='white')
fig.text(0.35,0.81,'*',size=20)
fig.text(0.695,0.81,'*',size=20,color='white')
fig.text(0.782,0.81,'*',size=20)

fig.text(0.265,0.58,'*',size=20)
fig.text(0.265,0.35,'*',size=20)
#fig.text(0.695,0.33,'*',size=20,color='white')
#plt.setp(label_y, rotation=360, horizontalalignment='right')
plt.show()
fig.savefig('fig%s_pcor_long.png'%(pyID),dpi=300)






