#!/usr/bin/env python
# coding: utf-8

# In[1]:


# >>>> load module
#%matplotlib inline
import pandas as pd
import numpy as np
import netCDF4
# from netCDF4 import Dataset
import matplotlib.pyplot as plt
import scipy.stats as ss
#import warnings; warnings.simplefilter('ignore')
import math
pyID='04a'


# In[21]:


# -----a_matrix------
def a_matrix():
    a_ma = np.zeros([nx,nx])
    for j in range(nx):
        a_ma[j,j]=-1.0
        
    #----default version : fixed CUE-------     
    a_ma[2,0]=0.5
    a_ma[2,6]=0.5
    a_ma[2,1]=0.25
    a_ma[3,1]=0.7
    a_ma[3,6]=0.7
    a_ma[3,0]=0.35
    a_out=a_ma
    return a_out
#--------kk_matrix------
def kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt):
    xtv=100.0
    kk_out=np.zeros(nx)
    
    iabove=1
    ibelow=2
    imetabolic=1
    istructural=2
    
    
    tvref = math.sqrt(fnpp/xtv)
    tvref = max(0.6,min(1.3,tvref))# 0.8-1.2 based on Wieder et al., 2015
    tvr = 0.00052 *tvref * math.exp(0.3*fmetave)*dt# *x(4)
    tvk = 0.00024 *tvref * math.exp(0.1*fmetave)*dt#  *x(4)
    kk_out[2]=tvr
    kk_out[3]=tvk
    return kk_out    

#------- modelx_control--------
def modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    soilden=2.65 # g cm^-3 soil particle density
    ################ SOIL MOISTURE FUNCTION IN ORCHIDEE ############
    moist_coeff1=1.1
    moist_coeff2=2.4
    moist_coeff3=0.29
    moistcont_min=0.25
    #moistfunc_result=-moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in - moist_coeff3
    moistfunc_result=moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in + moist_coeff3
    control_moist=max(moistcont_min, min(1,moistfunc_result))  #ORCHIDEE
    ##############################################################
    nx=7
    fm=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    fs=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    kor=4.0 # ZHC 6.0 --> 4.0
    kok=4.0 # ZHC 6.0 --> 4.0
    Q1=kor
    Q2=kok

    xvlit= 1.0 # 10.587669
    xvsoc= 1.0  # 23.601484
    xwlit= 1.0  # 2.266886
    xwsoc= 1.0  # 16.683772 
    xklit= 1.0  # 28.889871
    xksoc= 1.0  # 38.088382
    xjlit= 1.0  # 7.25338
    xjsoc= 1.0 # 52.29386
    #xav=x[0]
    #xak=x[1]
    #xdesorp= x[2] #*sum(cpool(5))/100% /(sum(cpool(5:7))/100)%%%% ZHC % 5.513930
    #fbs=math.exp(x[4]*bs)


    desorp = xdesorp * (1.5e-5) * math.exp(-1.5*clay)*dt #(1-exp(-x(4)*cpool(5))) % 0.021570
    # ********** Vmaxt **********
    sv = 0.063
    av = xav*8.0e-6 
    bv = 5.47 #ZHC: xav*1.25e-8 ---> xav*8.0e-6
    xv1=10.0 
    xv2=2.0 
    xv3=10.0 # xv1=10.0; xv2=2.0; xv3=10.0;
    xw1=3.0 
    xw2=3.0 
    xw3=2.0   # xw1=3.0; xw2=3.0; xw3=2.0;
    vmax = av * math.exp(sv*tem + bv) * dt*  control_moist
    V1 =  xv1 * vmax*xvlit # 10 * vmax 
    V2 =  xv2 * vmax*xvlit # 2 * vmax
    V3 =  xv3 * vmax*xvsoc # 10 * vmax 
    W1 =  xw1 * vmax*xwlit # 3 * vmax 
    W2 =  xw2 * vmax*xwlit # 3 * vmax 
    W3 =  xw3 * vmax*xwsoc # 2 * vmax 

    # ********** Kmt **********
    sk =0.02
    ak = xak*10.0 
    bk = 3.19 # ZHC: ak = 0.015625 ---> ak = 10
    xk1 =8.0 
    xk2 = 2.0
    xk3 = 4.0      # xk1 =8.0; xk2 = 2.0; xk3 = 4.0;
    xj1=2.0 
    xj2=4.0 
    xj3 = 6.0         # xj1=2.0; xj2=4.0; xj3 = 6.0;
    xkclay = 1.0/math.exp(-2.0*math.sqrt(clay))   # ZHC: 3.0/exp(-2.0*sqrt(clay)) --->1.0/exp(-2.0*sqrt(clay))
    sk=0.017
    km =  ak*math.exp(sk*tem+bk)*control_moist
    K1 =  xklit*km/xk1        # km/8.0;
    K3 =  xksoc*km*xkclay/xk3  # km*(1-4)/4;
    J1 =  xjlit*km/xj1        # km/2.0
    J3 =  xjsoc*km*xkclay/xj3  # km/*(1-4)/6;
    #
    sk=0.027
    km = ak*math.exp(sk*tem+bk)*control_moist
    K2 =  xklit*km/xk2         # km/2.0
    J2 =  xjlit*km/xj2         # km/4.0

    # **** Changes in C pools
    # dmbc3=kk_ma(3)*(cpool(3)) # turnover of MBC3;
    # dmbc4=kk_ma(4)*(cpool(4)) # turnover of MBC4;
    dmbc3=kk_ma[2]*(cpool[2]**beta) # turnover of MBC3; .^x(6) % 1.140941
    dmbc4=kk_ma[3]*(cpool[3]**beta) # turnover of MBC4; .^x(6) % 1.140941
    #--------------sorption functin--------------
    # from Wang et al., 2013, Mayes et al., 2012
    #kdes=0.001
    #kba=0.0006
    kdes=desorp
    kads=kdes*kba
    #c1=0.595 #0.297
    #c2=2.279 #3.355
    Qmax=10**(c1*np.log10(clay*100)+c2)*rho_b/1000

    y=np.zeros(nx)
    y[0] = litinpc[0]*(1.0-fm)-cpool[0] * (V1 * cpool[2]/(K1 + cpool[0])+W1*cpool[3]/(J1+cpool[0]))
    y[1] = litinpc[1]*(1.0-fs) -cpool[1]*(V2*cpool[2]/(K2+cpool[1])+W2*cpool[3]/(J2+cpool[1]))
    y[2] = a_ma[2,0]*V1*cpool[0]*cpool[2]/(K1+cpool[0])+ a_ma[2,1]*V2*cpool[1]*cpool[2]/(K2+cpool[1])+ a_ma[2,6]*V3*cpool[6]*cpool[2]/(K3+cpool[6])-dmbc3     
    y[3] = a_ma[3,0]*W1*cpool[0]*cpool[3]/(J1+cpool[0])+ a_ma[3,1]*W2*cpool[1]*cpool[3]/(J2+cpool[1])+ a_ma[3,6]*W3*cpool[6]*cpool[3]/(J3+cpool[6])-dmbc4
    y[4] = litinpc[0]*fm+fr2p*dmbc3+fk2p*dmbc4 + kads*(1-cpool[4]/Qmax)*cpool[6]- desorp*cpool[4]
    y[5] = litinpc[1]*fs+fr2c*dmbc3+fk2c*dmbc4- V2*cpool[5]*cpool[2]/(Q1*K2+cpool[5]) - W2*cpool[5]*cpool[3]/(Q2*J2+cpool[5])
    y[6] = fr2a*dmbc3+fk2a*dmbc4+ desorp*cpool[4]+ V2*cpool[5]*cpool[2]/(Q1*K2+cpool[5])+ W2*cpool[5]*cpool[3]/(Q2*J2+cpool[5])- V3*cpool[6]*cpool[2]/(K3+cpool[6]) - W3*cpool[6]*cpool[3]/(J3+cpool[6]) -kads*(1-cpool[4]/Qmax)*cpool[6]   
    return y
#-----modeljacx---------
def modeljacx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    eps = 1.0e-4
    y0=np.zeros(nx)
    y1=np.zeros(nx)
    dydx=np.zeros([nx,nx])
    y0 = modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
    for j in range(nx):
        temp=cpool[j]
        h=eps*abs(temp)
        if h<=0.0:
            h=eps
        cpool[j]=temp+h
        h=cpool[j]-temp
        y1=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool[j]=temp
        for ipool in range(nx):
            dydx[ipool,j]=(y1[ipool]-y0[ipool])/h
    return dydx 

#------------- luccmp ---------------
def ludcmp(dydx,index):
    nmax=500
    tiny=1.0e-20
    d=1.0
    vv=np.zeros(nmax)
    #index=np.zeros(nx)
    dydx1=np.zeros([nx,nx])
    indx=np.zeros(nx)
    dum=np.zeros(nx)
    for i in range(nx):
        aamax=0.0
        for j in np.arange(nx):

            if (abs(dydx[i,j])>aamax):
                aamax=abs(dydx[i,j])
        if (aamax==0.0):
            print('singular matrix in ludcmp')
            dydx1[:,:]=dydx[:,:]
            break
        vv[i]=1./aamax
    for j in range(nx):
        for i in range(j):
            summ=dydx[i,j]
            for k in range(i):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
        aamax=0.
        for i in range(j,nx):  ##1111111
            summ=dydx[i,j]
            for k in range(0,j):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
            dum=vv[i]*abs(summ)
            if (dum>=aamax):
                imax=i
                aamax=dum
        if (j!=imax):
            for k in range(nx):
                dum=dydx[imax,k]
                dydx[imax,k]=dydx[j,k]
                dydx[j,k]=dum
            d=-d
            vv[imax]=vv[j]
        index[j]=imax
        if(dydx[j,j]==0):
            dydx[j,j]=tiny
        if(j!=nx-1):
            dum=1./dydx[j,j]
            for i in np.arange(j+1,nx): #11111111
                dydx[i,j]=dydx[i,j]*dum
        dydx1[:,:]=dydx[:,:]
        indx[:]=index[:]
    return dydx1,indx,d
#-------------- ludksb ----------------
def ludksb(dydx1,indx,p):
    ii=-1
    #p=np.zeros(nx)
    for i in range(nx):
        ll=int(indx[i])
        sumerr=p[ll]
        p[ll]=p[i]
        if (ii!=-1):
            for j in np.arange(ii,i): 
                sumerr=sumerr-dydx1[i,j]*p[j]
        elif (sumerr!= 0):
            ii=i

        p[i]=sumerr
    for i in range(nx-1,-1,-1):   #111111
        sumerr=p[i]
        for j in np.arange(i+1,nx):
            sumerr=sumerr-dydx1[i,j]*p[j]
        p[i]=sumerr/dydx1[i,i]
    return p 

#----------------- mnewt -----------------
def mnewt(ntrial,npm,cpool,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,tem,clay,bs,rho_b,moist_in,dt,tolx,tolf,
          fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    index=np.zeros(nx)
    indx=np.zeros(nx)
    p=np.zeros(nx)
    #p1=np.zeros(nx)
    iflagxy = 0
    for k in range(ntrial):
        y=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        dydx=modeljacx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        errf=0.0
        for i in range(nx):
            dxy = max(abs(min(dydx[i,:])), abs(max(dydx[i,:])))
            if dxy==0.0:
                iflagxy=1
                break
            errf=errf+abs(y[i])

        if (errf<=tolf):
            break
        if (iflagxy==1):
            cpool[:] = 0.0
            break  
        for i in np.arange(nx):
            p[i]=-y[i]
        dydx1,indx,d=ludcmp(dydx,index)

        #---new from HZ1---
        iflagnon=1
        for i in range(nx):
            AA = np.isnan(dydx1[i,:])
            numAA = np.sum(AA) 
            if (numAA==nx):
                print('singular matrix in none value')
                iflagnon=0
                cpool[:] = -999
                break   
        if (iflagnon==0):
            break 
        p1=ludksb(dydx1,indx,p)
        errx=0.0  
        for i in range(nx):
            errx=errx+abs(p1[i])
            cpool[i]=min(max(cpool[i]+p1[i],0.0001),1000)
        if (errx<=tolx):
            break
    return cpool[:]    

################ biochar ###################
################ biochar ###################
def a_matrix_bc(fcue):
    a_ma = np.zeros([nx,nx])
    for j in range(nx):
        a_ma[j,j]=-1.0
        
    #----default version : fixed CUE-------     
    a_ma[2,0]=0.5*fcue
    a_ma[2,6]=0.5*fcue
    a_ma[2,1]=0.25*fcue
    a_ma[3,1]=0.7*fcue
    a_ma[3,6]=0.7*fcue
    a_ma[3,0]=0.35*fcue
    a_out=a_ma
    return a_out

def kk_matrix_bc(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,dt,ftao):
    xtv=100.0
    kk_out=np.zeros(nx)
    
    iabove=1
    ibelow=2
    imetabolic=1
    istructural=2
    
    
    tvref = math.sqrt(fnpp/xtv)
    tvref = max(0.6,min(1.3,tvref))# 0.8-1.2 based on Wieder et al., 2015
    tvr = 0.00052 *tvref * math.exp(0.3*fmetave)*dt# *x(4)
    tvk = 0.00024 *tvref * math.exp(0.1*fmetave)*dt#  *x(4)
    kk_out[2]=tvr*ftao
    kk_out[3]=tvk*ftao
    return kk_out  


def modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    soilden=2.65 # g cm^-3 soil particle density
    ################ SOIL MOISTURE FUNCTION IN ORCHIDEE ############
    moist_coeff1=1.1
    moist_coeff2=2.4
    moist_coeff3=0.29
    moistcont_min=0.25
    #moistfunc_result=-moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in - moist_coeff3
    moistfunc_result=moist_coeff1*moist_in*moist_in + moist_coeff2*moist_in + moist_coeff3
    control_moist=max(moistcont_min, min(1,moistfunc_result))  #ORCHIDEE
    ##############################################################
    nx=7
    fm=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    fs=0.05 #min(1.0,x(5)*exp(-x(4)*0.001*bulkd/soilden))
    kor=4.0 # ZHC 6.0 --> 4.0
    kok=4.0 # ZHC 6.0 --> 4.0
    Q1=kor
    Q2=kok

    xvlit= 1.0 # 10.587669
    xvsoc= 1.0  # 23.601484
    xwlit= 1.0  # 2.266886
    xwsoc= 1.0  # 16.683772 
    xklit= 1.0  # 28.889871
    xksoc= 1.0  # 38.088382
    xjlit= 1.0  # 7.25338
    xjsoc= 1.0 # 52.29386
    #xav=x[0]
    #xak=x[1]
    #xdesorp= x[2] #*sum(cpool(5))/100% /(sum(cpool(5:7))/100)%%%% ZHC % 5.513930
    #fbs=math.exp(x[4]*bs)


    desorp = xdesorp * (1.5e-5) * math.exp(-1.5*clay)*dt *(1+fprim*rate_bc*bc_c/1000)    #(1-exp(-x(4)*cpool(5))) % 0.021570
    # ********** Vmaxt **********
    sv = 0.063
    av = xav*8.0e-6 
    bv = 5.47 #ZHC: xav*1.25e-8 ---> xav*8.0e-6
    xv1=10.0 
    xv2=2.0 
    xv3=10.0 # xv1=10.0; xv2=2.0; xv3=10.0;
    xw1=3.0 
    xw2=3.0 
    xw3=2.0   # xw1=3.0; xw2=3.0; xw3=2.0;
    vmax = av * math.exp(sv*tem + bv) * dt* control_moist*(1+dvmax*rate_bc*bc_c/1000)
    V1 =  xv1 * vmax*xvlit # 10 * vmax 
    V2 =  xv2 * vmax*xvlit # 2 * vmax
    V3 =  xv3 * vmax*xvsoc # 10 * vmax 
    W1 =  xw1 * vmax*xwlit # 3 * vmax 
    W2 =  xw2 * vmax*xwlit # 3 * vmax 
    W3 =  xw3 * vmax*xwsoc # 2 * vmax 

    # ********** Kmt **********
    sk =0.02
    ak = xak*10.0 
    bk = 3.19 # ZHC: ak = 0.015625 ---> ak = 10
    xk1 =8.0 
    xk2 = 2.0
    xk3 = 4.0      # xk1 =8.0; xk2 = 2.0; xk3 = 4.0;
    xj1=2.0 
    xj2=4.0 
    xj3 = 6.0         # xj1=2.0; xj2=4.0; xj3 = 6.0;
    xkclay = 1.0/math.exp(-2.0*math.sqrt(clay))   # ZHC: 3.0/exp(-2.0*sqrt(clay)) --->1.0/exp(-2.0*sqrt(clay))
    sk=0.017
    km =  ak*math.exp(sk*tem+bk)* control_moist
    K1 =  xklit*km/xk1        # km/8.0;
    K3 =  xksoc*km*xkclay/xk3  # km*(1-4)/4;
    J1 =  xjlit*km/xj1        # km/2.0
    J3 =  xjsoc*km*xkclay/xj3  # km/*(1-4)/6;
    #
    sk=0.027
    km = ak*math.exp(sk*tem+bk)* control_moist
    K2 =  xklit*km/xk2         # km/2.0
    J2 =  xjlit*km/xj2         # km/4.0

    # **** Changes in C pools
    # dmbc3=kk_ma(3)*(cpool(3)) # turnover of MBC3;
    # dmbc4=kk_ma(4)*(cpool(4)) # turnover of MBC4;
    dmbc3=kk_ma[2]*(cpool_bc[2]**beta) # turnover of MBC3; .^x(6) % 1.140941
    dmbc4=kk_ma[3]*(cpool_bc[3]**beta) # turnover of MBC4; .^x(6) % 1.140941
    #------- sorption function ------
    # from Wang et al., 2013, Mayes et al., 2012
    #kdes=0.001
    #kba=0.0006
    kdes=desorp
    kads=kdes*kba
    #c1=0.595 #0.297
    #c2=2.279 #3.355
    Qmax=10**(c1*np.log10(clay*100)+c2)*rho_b/1000
    #------- sorption function ------    
    y=np.zeros(nx)
    y[0] = litinpc[0]*(1.0-fm)-cpool_bc[0] * (V1 * cpool_bc[2]/(K1 + cpool_bc[0])+W1*cpool_bc[3]/(J1+cpool_bc[0]))
    y[1] = litinpc[1]*(1.0-fs) -cpool_bc[1]*(V2*cpool_bc[2]/(K2+cpool_bc[1])+W2*cpool_bc[3]/(J2+cpool_bc[1]))
    y[2] = a_ma[2,0]*V1*cpool_bc[0]*cpool_bc[2]/(K1+cpool_bc[0])+ a_ma[2,1]*V2*cpool_bc[1]*cpool_bc[2]/(K2+cpool_bc[1])+ a_ma[2,6]*V3*cpool_bc[6]*cpool_bc[2]/(K3+cpool_bc[6])-dmbc3     
    y[3] = a_ma[3,0]*W1*cpool_bc[0]*cpool_bc[3]/(J1+cpool_bc[0])+ a_ma[3,1]*W2*cpool_bc[1]*cpool_bc[3]/(J2+cpool_bc[1])+ a_ma[3,6]*W3*cpool_bc[6]*cpool_bc[3]/(J3+cpool_bc[6])-dmbc4
    y[4] = litinpc[0]*fm+fr2p*dmbc3+fk2p*dmbc4+ kads*(1-cpool_bc[4]/Qmax)*cpool_bc[6]  - desorp*cpool_bc[4]
    y[5] = litinpc[1]*fs+fr2c*dmbc3+fk2c*dmbc4- V2*cpool_bc[5]*cpool_bc[2]/(Q1*K2+cpool_bc[5]) - W2*cpool_bc[5]*cpool_bc[3]/(Q2*J2+cpool_bc[5])
    y[6] = fr2a*dmbc3+fk2a*dmbc4+ desorp*cpool_bc[4]+ V2*cpool_bc[5]*cpool_bc[2]/(Q1*K2+cpool_bc[5])+ W2*cpool_bc[5]*cpool_bc[3]/(Q2*J2+cpool_bc[5])- V3*cpool_bc[6]*cpool_bc[2]/(K3+cpool_bc[6]) - W3*cpool_bc[6]*cpool_bc[3]/(J3+cpool_bc[6]) -kads*(1-cpool_bc[4]/Qmax)*cpool_bc[6]   
    return y

def modeljacx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    eps = 1.0e-4
    y0=np.zeros(nx)
    y1=np.zeros(nx)
    dydx=np.zeros([nx,nx])
    y0 = modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
    for j in range(nx):
        temp=cpool_bc[j]
        h=eps*abs(temp)
        if h<=0.0:
            h=eps
        cpool_bc[j]=temp+h
        h=cpool_bc[j]-temp
        y1=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim, dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool_bc[j]=temp
        for ipool in range(nx):
            dydx[ipool,j]=(y1[ipool]-y0[ipool])/h
    return dydx 

def ludcmp_bc(dydx,index):
    nmax=500
    tiny=1.0e-20
    d=1.0
    vv=np.zeros(nmax)
    #index=np.zeros(nx)
    dydx1=np.zeros([nx,nx])
    indx=np.zeros(nx)
    dum=np.zeros(nx)
    for i in range(nx):
        aamax=0.0
        for j in np.arange(nx):

            if (abs(dydx[i,j])>aamax):
                aamax=abs(dydx[i,j])
        if (aamax==0.0):
            print('singular matrix in ludcmp')
            dydx1[:,:]=dydx[:,:]
            break
        vv[i]=1./aamax
    for j in range(nx):
        for i in range(j):
            summ=dydx[i,j]
            for k in range(i):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
        aamax=0.
        for i in range(j,nx):  ##1111111
            summ=dydx[i,j]
            for k in range(0,j):
                summ=summ-dydx[i,k]*dydx[k,j]
            dydx[i,j]=summ
            dum=vv[i]*abs(summ)
            if (dum>=aamax):
                imax=i
                aamax=dum
        if (j!=imax):
            for k in range(nx):
                dum=dydx[imax,k]
                dydx[imax,k]=dydx[j,k]
                dydx[j,k]=dum
            d=-d
            vv[imax]=vv[j]
        index[j]=imax
        if(dydx[j,j]==0):
            dydx[j,j]=tiny
        if(j!=nx-1):
            dum=1./dydx[j,j]
            for i in np.arange(j+1,nx): 
                dydx[i,j]=dydx[i,j]*dum
        dydx1[:,:]=dydx[:,:]
        indx[:]=index[:]
    return dydx1,indx,d

def ludksb_bc(dydx1,indx,p):
    ii=-1
    #p=np.zeros(nx)
    for i in range(nx):
        ll=int(indx[i])
        sumerr=p[ll]
        p[ll]=p[i]
        if (ii!=-1):
            for j in np.arange(ii,i): 
                sumerr=sumerr-dydx1[i,j]*p[j]
        elif (sumerr!= 0):
            ii=i

        p[i]=sumerr
    for i in range(nx-1,-1,-1):   #111111
        sumerr=p[i]
        for j in np.arange(i+1,nx):
            sumerr=sumerr-dydx1[i,j]*p[j]
        p[i]=sumerr/dydx1[i,i]
    return p 
#----------------- mnewt -----------------
def mnewt_bc(ntrial,npm,cpool_bc,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,tolx,tolf,
          fr2p,fk2p,fr2c,fk2c,fr2a,fk2a):
    index=np.zeros(nx)
    indx=np.zeros(nx)
    p=np.zeros(nx)
    #p1=np.zeros(nx)
    iflagxy = 0
    for k in range(ntrial):
        y=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        dydx=modeljacx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        errf=0.0
        for i in range(nx):
            dxy = max(abs(min(dydx[i,:])), abs(max(dydx[i,:])))
            if dxy==0.0:
                iflagxy=1
                break
            errf=errf+abs(y[i])

        if (errf<=tolf):
            break
        if (iflagxy==1):
            cpool_bc[:] = 0.0
            break  
        for i in np.arange(nx):
            p[i]=-y[i]
        dydx1,indx,d=ludcmp_bc(dydx,index)

        #---new from HZ1---
        iflagnon=1
        for i in range(nx):
            AA = np.isnan(dydx1[i,:])
            numAA = np.sum(AA) 
            if (numAA==nx):
                print('singular matrix in none value')
                iflagnon=0
                cpool_bc[:] = -999
                break   
        if (iflagnon==0):
            break 
        p1=ludksb_bc(dydx1,indx,p)
        errx=0.0  
        for i in range(nx):
            errx=errx+abs(p1[i])
            cpool_bc[i]=min(max(cpool_bc[i]+p1[i],0.0001),1000)
        if (errx<=tolx):
            break
    return cpool_bc[:]
# -------calculate steady state SOC from MIMICS_T------
def matrix_fun(xav,xak,xdesorp,beta,kba,c1,c2,obs,f_grain):
    nx=7
    one_year=365
    one_day=86400
    emax=0.8
    cue_coef1=0.662
    cue_coef2=0.5
    m_fdecomp=296.8
    
    clay = 0.2
    partden=2.65 # soil particle density
    
    lignin_struc_cmatrix = 0.76  # lignin in matrix_nextlitter
    litter_struct_coef = 3. 
    cn_r=[30.,30., 7.4, 13.4, 12., 16., 10.] # C/N ratio for [abo_meta,bel_meta,abo_stru,bel_stru,active,slow,passive]
    cn_rr=7.4
    cn_rk=13.4
    
    
    dt=1 # time step = 1 hour
    nd=365
    ntrial=100
    #npm=len(x) # number of optimized parameters
    npm=3
    nobs=len(obs)
    # soil_weight=1. ;% kg, weight of soil
    tolx=0.0001
    tolf=0.000001
    f=0
    sd1=0
    sdlitt=0
    sdsoc=0

    ng=len(obs)
    nsamp=ng
    kk=np.zeros([ng,nx])
    fmic=np.zeros(ng)
    fphys=np.zeros(ng)
    fchem=np.zeros(ng)
    favail=np.zeros(ng)

    cpool_equlib=np.zeros([nobs,nx])
    cpool_eq=np.zeros(nx)
    CXY=np.zeros([nobs,2])
    ncxy=0
    #
    for ig in range(ng):
        #isam=obs.loc[group(ig),2]
        isam=ig
        #tem=obs.loc[isam,'MAT_WC']  # Celcius degree (℃)
        tem=obs.loc[isam,'MAT'] 
        #swc=obs.loc[isam,'SWC'] # 0-1
        #clay=obs.loc[isam,'CLAY_GSDE_30cm'] # 0-1
        clay=obs.loc[isam,'Clay'] 
        fnpp=obs.loc[isam,'NPP_MODIS']
        #mineral_n = obs.loc[isam,'MineralN(mg N/kg)']*0.001 # mineral N mg/kg --> g/kg
        sdepth=obs.loc[isam,'Sdepth_ini']# # cm
        bulkd=obs.loc[isam,'Con_BD'] # 
        rho_b=obs.loc[isam,'Con_BD'] # 
        moist_in=obs.loc[isam,'SM']
        #socobs=obs.loc[isam,'SOC(g/kg)'] # gC/kg soil, SOC concentration
  
    #----------------------------------
        #f_grain=0.45
        dleafc=fnpp*3/10*(1-f_grain)   # g C m^-2 yr^-1
        drootc=fnpp/5   # g C m^-2 yr^-1
        dwoodc=fnpp/2*(1-f_grain)  # g C m^-2 yr^-1
        cnleaf=25#30    # leaf C:N ratio
        cnroot=45  # root C:N ratio
        cnwood=50#30 # wood C:N ratio
        fligleaf=0.12#0.2 # leaf lignin:C
        fligroot=0.4#0.45 # root lignin:C
        fligwood=0.15#0.35 # wood lignin:C

        bs=obs.loc[isam,'BS_GSDE_30cm'] #base saturation  #mhan,暂时

        dleaf=0.1*dleafc/(24*365.0)/sdepth*dt    # mgc/cm3/day %*x(3)
        droot=0.1*drootc/(24*365.0)/sdepth*dt    # mgc/cm3/day %*x(3)
        dwood=0.1*dwoodc/(24*365.0)/sdepth*dt   #mgc/cm3/day %*x(3)
        fmetleaf=max(0.0,1.0*(0.85-0.013*fligleaf*cnleaf))
        fmetroot=max(0.0,1.0*(0.85-0.013*fligroot*cnroot))
        fmetwood=max(0.0,1.0*(0.85-0.013*fligwood*cnwood))
        fmetave = (dleaf*fmetleaf+droot*fmetroot+dwood*fmetwood)/(dleaf + droot + dwood+ 1.0e-10)
        # Fresh litter input at each time step
        litinpc=np.zeros(nx)
        litinpc[0]=fmetleaf*dleaf+fmetwood*dwood+fmetroot*droot
        litinpc[1]=(1-fmetleaf)*dleaf+(1-fmetwood)*dwood+(1.0-fmetroot)*droot
        #
        #cn_r[0]=litinpc[0]/(dleaf*fmetleaf/cnleaf+dwood*fmetwood/cnwood+droot*fmetroot/cnroot)
        #cn_r[1]=litinpc[1]/(dleaf*(1.0-fmetleaf)/cnleaf+dwood*(1.0-fmetwood)/cnwood+droot*(1.0-fmetroot)/cnroot)
        #cn_r[2]=cn_rr
        #cn_r[3]=cn_rk
        #
        #lignin_struc_cmatrix = min(0.99,(dleaf*(1.0-fmetleaf)*min(1.0,fligleaf/(1.0-fmetleaf))+dwood*(1.0-fmetwood)*min(1.0,fligwood/(1.0-fmetwood))+droot*(1.0-fmetroot)*min(1.0,fmetroot/(1.0-fmetroot)))/litinpc[2])
        #
        x6=0.432
        x7=0.098
        x8=10.56
        x9=29.78
        x10=2.61
        fr2p = min(1.0,x6*0.3 * math.exp(1.3*clay))   # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
        fk2p = min(1.0,x7*0.20 * math.exp(0.8*clay))  # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
        fr2c = min(1.0-fr2p, x8*0.10 * math.exp(-x10*fmetave))  # ! 9.0    to invoid a negative value of fr2a ZHC
        fk2c = min(1.0-fk2p, x9*0.30 * math.exp(-x10*fmetave))  # x(2*nsamp+5) ! 9.0    to invoid a negative value of fk2a ZHC
        fr2a = 1.00 - fr2p - fr2c
        fk2a = 1.00 - fk2p - fk2c
        cpool_ini=np.zeros(nx)
        cpool=np.zeros(nx)
        cpool_ini[0:7]=np.array([0.1,0.2,0.05,0.1,0.1,1.0,2.0])   # initial C pool
        cpool[0:7]=cpool_ini[0:7] # C pool
        #mineralN=np.zeros(nx)
        #mineralN[0,0]=mineral_n # Soil mineral N concentration (g N/ kg soil)
        #mineralN[0,1]=0 # Loss of N gas (g N/ kg soil)
        kk_ma = kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt)
        #n_cue=np.zeros(nx)
        #n_cue[0]=mineral_n-cue_coef2
        #n_cue[1]=mineral_n-cue_coef2
        a_ma = a_matrix()  # Start simulation

        cpool[:]=cpool_ini[:]
        cpool_eq=mnewt(ntrial,npm,cpool,litinpc,a_ma,kk_ma,fnpp,xav,xak,xdesorp,beta,kba,c1,c2,tem,clay,bs,rho_b,moist_in,dt,tolx,tolf,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
        cpool_equlib[isam,:]=cpool_eq[:]
        #sdsoc=sdsoc+(sum(cpool_eq[2:7])/(0.001*bulkd)-socobs)**2

    return cpool_equlib    

# ----------matrix_funs----------------------
# RUN FROM STEADY WITH NORMAL SPIN UP
# RUN CONTROL AND BIOCHAR TREATMENT TASTS
#--------------------------------------------

def matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp):

    xav= 15.9079
    xak= 13.1022
    xdesorp= 1.59835
    beta= 1.47245
    kba=2.952
    c1= 0.513437
    c2= 3.86153


    nx=7
    one_year=365
    one_day=86400
    emax=0.8
    cue_coef1=0.662
    cue_coef2=0.5
    m_fdecomp=296.8
    
    #clay = 0.2
    partden=2.65 # soil particle density
    
    lignin_struc_cmatrix = 0.76  # lignin in matrix_nextlitter
    litter_struct_coef = 3. 
    cn_r=[30.,30., 7.4, 13.4, 12., 16., 10.] # C/N ratio for [abo_meta,bel_meta,abo_stru,bel_stru,active,slow,passive]
    cn_rr=7.4
    cn_rk=13.4
    
    
    dt=1 # time step = 1 hour
    nd=365
    ntrial=100
    #npm=len(x) # number of optimized parameters
    npm=3
    nobs=len(obs)
    # soil_weight=1. ;% kg, weight of soil
    tolx=0.0001
    tolf=0.000001
    f=0
    sd1=0
    sdlitt=0
    sdsoc=0

    ng=len(obs)
    nsamp=ng
    kk=np.zeros([ng,nx])
    fmic=np.zeros(ng)
    fphys=np.zeros(ng)
    fchem=np.zeros(ng)
    favail=np.zeros(ng)

    cpool_equlib=np.zeros([nobs,nx])
    cpool_equlib_bc=np.zeros([nobs,nx])
    
    cpool_eq=np.zeros(nx)
    cpool_eq_bc=np.zeros(nx)
    #
    RR=np.zeros(ng)
    RC=np.zeros(ng)
    AC=np.zeros(ng)
    
    CXY=np.zeros([nobs,2])
    ncxy=0
    #
    for ig in range(ng):
        #isam=obs.loc[group(ig),2]
        isam=ig
        #tem=obs.loc[isam,'MAT_WC']  # Celcius degree (℃)
        tem=obs.loc[isam,'MAT'] 
        #swc=obs.loc[isam,'SWC'] # 0-1
        #clay=obs.loc[isam,'CLAY_GSDE_30cm'] # 0-1
        clay=obs.loc[isam,'Clay']*fclay 
        #fnpp=obs.loc[isam,'NPP_MODIS']
        #mineral_n = obs.loc[isam,'MineralN(mg N/kg)']*0.001 # mineral N mg/kg --> g/kg
        sdepth=obs.loc[isam,'Sdepth_ini']# # cm
        bulkd=obs.loc[isam,'Con_BD'] #
        rho_b=obs.loc[isam,'Con_BD'] # 
        bulkd_bc=obs.loc[isam,'BD'] # 
        #socobs=obs.loc[isam,'SOC(g/kg)'] # gC/kg soil, SOC concentration
        landpoint=int(obs.loc[isam,'land_index'])      # used for 6 hr temperature
        # biochar related input
        rate_bc=obs.loc[isam,'Rate_BC']*frate  # t/ha
        bc_c=obs.loc[isam,'BC_C']        # g/kg
        age_bc=obs.loc[isam,'Age_BC']*fage    # yr
        moist_in=obs.loc[isam,'SM']*fsm
        #
        tem6hour=Tair[isam]
        npp24hour=npp[isam]

        
        cpool_ini=np.zeros(nx)
        cpool_ini_bc=np.zeros(nx)
        cpool_ini[0:7]=fbest[isam,:]   # initial C pool
        cpool=np.zeros(nx)  # control
        cpool_bc=np.zeros(nx) # biochar
        
        cpool[0:7]=cpool_ini[0:7] # C pool
        # the carbon in biochar is added in equilibrium SOC in MIMICS
        carb_bc=10*rate_bc*bc_c/1000/sdepth   # mg/cm3
        floss=0.02
        #fbp=0.6 # 0.5~0.8
        #fba=0.2  #0~0.3
        fbc=1-fbp-fba #
        
        carb_bc_p=carb_bc *(1-floss)*fbp
        carb_bc_a=carb_bc *(1-floss)*fba
        carb_bc_c=carb_bc *(1-floss)*fbc
       
        cpool_ini_bc[0]=cpool_ini[0]
        cpool_ini_bc[1]=cpool_ini[1]
        cpool_ini_bc[2]=cpool_ini[2]
        cpool_ini_bc[3]=cpool_ini[3]
        cpool_ini_bc[4]=cpool_ini[4]+carb_bc_p  # add biochar carbon in SOMp
        cpool_ini_bc[5]=cpool_ini[5]+carb_bc_c  # add biochar carbon in SOMc
        cpool_ini_bc[6]=cpool_ini[6]+carb_bc_a  # add biochar carbon in SOMa
        
        cpool_bc[0:7]=cpool_ini_bc[0:7] # C pool
        #mineralN=np.zeros(nx)
        #mineralN[0,0]=mineral_n # Soil mineral N concentration (g N/ kg soil)
        #mineralN[0,1]=0 # Loss of N gas (g N/ kg soil)

        cpool[:]=cpool_ini[:]
        cpool_bc[:]=cpool_ini_bc[:]
        
        nyr =age_bc
        nday = 365
        nhour = 24
        ntime = int(nyr*nday*nhour)
        #out1 = np.zeros([7,nyr,nday,nhour])    
        #out2 = np.zeros([7,nyr,nday,nhour])
        out1 = np.zeros([ntime,7])    
        out2 = np.zeros([ntime,7])   

        segments1 = [i for i in range(1460) for _ in range(6)]*10  # index for reading 6 hr tem input data,max year is 6 year    
        segments2 = [i for i in range(365) for _ in range(24)]*10  # fnpp
        for i in range(ntime):
            m1=segments1[i]
            m2=segments2[i]
            #tem=Tair[m1,landpoint]-273.15    # K->℃
            #fnpp=nppt[m2]
            tem=tem6hour[m1]
            fnpp=npp24hour[m2]*fnp
            #----------------------------------
            #f_grain=0.45
            dleafc=fnpp*3/10*(1-f_grain)   # g C m^-2 yr^-1
            drootc=fnpp/5   # g C m^-2 yr^-1
            dwoodc=fnpp/2*(1-f_grain)  # g C m^-2 yr^-1
            cnleaf=25#30    # leaf C:N ratio
            cnroot=45  # root C:N ratio
            cnwood=50#30 # wood C:N ratio
            fligleaf=0.12#0.2 # leaf lignin:C
            fligroot=0.4#0.45 # root lignin:C
            fligwood=0.15#0.35 # wood lignin:C

            bs=obs.loc[isam,'BS_GSDE_30cm'] #base saturation  

            dleaf=0.1*dleafc/(24)/sdepth*dt    # mgc/cm3/day %*x(3)
            droot=0.1*drootc/(24)/sdepth*dt    # mgc/cm3/day %*x(3)
            dwood=0.1*dwoodc/(24)/sdepth*dt   #mgc/cm3/day %*x(3)
            fmetleaf=max(0.0,1.0*(0.85-0.013*fligleaf*cnleaf))
            fmetroot=max(0.0,1.0*(0.85-0.013*fligroot*cnroot))
            fmetwood=max(0.0,1.0*(0.85-0.013*fligwood*cnwood))
            fmetave = (dleaf*fmetleaf+droot*fmetroot+dwood*fmetwood)/(dleaf + droot + dwood+ 1.0e-10)
            # Fresh litter input at each time step
            litinpc=np.zeros(nx)
            litinpc[0]=fmetleaf*dleaf+fmetwood*dwood+fmetroot*droot
            litinpc[1]=(1-fmetleaf)*dleaf+(1-fmetwood)*dwood+(1.0-fmetroot)*droot
            #

            x6=0.432
            x7=0.098
            x8=10.56
            x9=29.78
            x10=2.61
            fr2p = min(1.0,x6*0.3 * math.exp(1.3*clay))   # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
            fk2p = min(1.0,x7*0.20 * math.exp(0.8*clay))  # !3.0 *x(5)*exp(-x(4)*0.001*bulkd/partden)
            fr2c = min(1.0-fr2p, x8*0.10 * math.exp(-x10*fmetave))  # ! 9.0    to invoid a negative value of fr2a ZHC
            fk2c = min(1.0-fk2p, x9*0.30 * math.exp(-x10*fmetave))  # x(2*nsamp+5) ! 9.0    to invoid a negative value of fk2a ZHC
            fr2a = 1.00 - fr2p - fr2c
            fk2a = 1.00 - fk2p - fk2c
            kk_ma = kk_matrix(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,dt)
            kk_ma_bc = kk_matrix_bc(fnpp,fmetave,tem,xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,dt,ftao) # add biochar
            #n_cue=np.zeros(nx)
            #n_cue[0]=mineral_n-cue_coef2
            #n_cue[1]=mineral_n-cue_coef2
            a_ma = a_matrix()  # Start simulation
            a_ma_bc = a_matrix_bc(fcue)  # Start simulation
        #-------------------------------
            y1=modelx(xav,xak,xdesorp,beta,kba,c1,c2,cpool,a_ma,litinpc,kk_ma,fnpp,tem,clay,bs,rho_b,moist_in,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
            cpool[0]=max(0,cpool[0]+y1[0])
            cpool[1]=max(0,cpool[1]+y1[1])
            cpool[2]=max(0,cpool[2]+y1[2])
            cpool[3]=max(0,cpool[3]+y1[3])
            cpool[4]=max(0,cpool[4]+y1[4])
            cpool[5]=max(0,cpool[5]+y1[5])
            cpool[6]=max(0,cpool[6]+y1[6])
            out1[i,:]=cpool    
            y2=modelx_bc(xav,xak,xdesorp,beta,kba,c1,c2,fprim,dvmax,cpool_bc,a_ma_bc,litinpc,kk_ma_bc,fnpp,tem,clay,bs,rho_b,moist_in,rate_bc,bc_c,dt,fr2p,fk2p,fr2c,fk2c,fr2a,fk2a)
            cpool_bc[0]=max(0,cpool_bc[0]+y2[0])
            cpool_bc[1]=max(0,cpool_bc[1]+y2[1])
            cpool_bc[2]=max(0,cpool_bc[2]+y2[2])
            cpool_bc[3]=max(0,cpool_bc[3]+y2[3])
            cpool_bc[4]=max(0,cpool_bc[4]+y2[4])
            cpool_bc[5]=max(0,cpool_bc[5]+y2[5])
            cpool_bc[6]=max(0,cpool_bc[6]+y2[6])
            out2[i,:]=cpool_bc  

        cpool_equlib[isam,:]=out1[-1,:]/bulkd 
        cpool_equlib_bc[isam,:]=out2[-1,:]/bulkd_bc 
        cpool_eq[:]=cpool_equlib[isam,:]
        cpool_eq_bc[:]=cpool_equlib_bc[isam,:]

        # target variables        
        AC[isam]=np.sum(cpool_eq_bc[4:7])-np.sum(cpool_eq[4:7]) 

    return AC
    #return np.sum(cpool_equlib[:,4:7],axis=1)


# In[22]:


######### Run model ##################      
nx=7
obs = pd.read_excel('/spotpy/examples/mimics_python/biochar_221123.xlsx', 'TableS1', index_col=None, na_values=['NA'])
obs = obs.reset_index(drop=True)
ndf1=len(obs)

xav1= 15.9079
xak1= 13.1022
xdesorp1= 1.59835
beta1= 1.47245
kba1=2.952
c11= 0.513437
c21= 3.86153

#fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)   # optimized parameters in MIMICS_T, for contro SOC
#print('analytical steady SOC:','\n',fbest) 

#------------RUN MODEL------------
Tair=np.load('H:/data/input_df/py02a_tem6hourly_agg.npy')
npp=np.load('H:/data/input_df/py02a_npp24hourly_agg.npy')
npp[npp<0]=0

# optimized values with averaged points
fbest1=np.zeros([ndf1,5])
'''
fprim0= 0.106557
dvmax0= -0.0474077
f_grain0=0.45
fbp0= 0.720123
fba0= 0.277646
frate0= 1.0
fage0=1.0

fnp0=1
fclay0=1
fsm0=1
fcue0=1
ftao0=1
'''
#---------------
fprim0= -0.00829004
dvmax0= 0.00802182
f_grain0=0.45
fbp0= 0.6
fba0= 0.2
frate0= 1.0
fage0=1.0

fnp0=1
fclay0=1
fsm0=1
fcue0=0.2
ftao0=0.2


sentest=[-0.5,-0.25,0,0.25,0.5]


# In[7]:


sentest=[-0.5,-0.25,0,0.25,0.5]
#fd (fprim)
for i in range(len(sentest)):
    fprim=fprim0*(1+sentest[i])
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fd:',i)
np.save('Smy%s_TSMb_fd.npy'%(pyID),fbest1) 

#fv (dvmax)
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0*(1+sentest[i])
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print('i',fbest1[:,i])
    print('fv:',i)
np.save('Smy%s_TSMb_fv.npy'%(pyID),fbest1) 

#HI(f_grain)
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0*(1+sentest[i])
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('HI',i)
np.save('H:/data/input_df/Smy%s_TSMb_HI.npy'%(pyID),fbest1) 

#fbp
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0*(1+sentest[i])
    fba=fba0
    frate=frate0
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fbp:',i)
np.save('H:/data/input_df/Smy%s_TSMb_fbp.npy'%(pyID),fbest1) 

#fba
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0*(1+sentest[i])
    frate=frate0
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fba:',i)
np.save('H:/data/input_df/Smy%s_TSMb_fba.npy'%(pyID),fbest1) 

#Rate_BC
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0*(1+sentest[i])
    fage=fage0
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0 
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('frate:',i)
np.save('H:/data/input_df/Smy%s_TSMb_frate.npy'%(pyID),fbest1) 

#-------------input parameters-----------
#Age_BC
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0*(1+sentest[i])
    #-------
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0    
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('frate:',i)
np.save('Smy%s_TSMb_fage.npy'%(pyID),fbest1) 


# In[8]:


#-------------input parameters-----------
#fnpp
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #----
    fnp=fnp0*(1+sentest[i])
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fnpp:',i)
np.save('/Smy%s_TSMb_fnpp.npy'%(pyID),fbest1) 

#-------------input parameters-----------
#fclay
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #----
    fnp=fnp0
    fclay=fclay0*(1+sentest[i])
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fclay:',i)
np.save('Smy%s_TSMb_fclay.npy'%(pyID),fbest1) 


# In[9]:


#-------------input parameters-----------
#fsm
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #----
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0*(1+sentest[i])
    fcue=fcue0
    ftao=ftao0
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fsm:',i)
np.save('Smy%s_TSMb_fsm.npy'%(pyID),fbest1) 


# In[23]:


#fcue
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #----
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0*(1+sentest[i])
    ftao=ftao0
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('fcue:',i)
np.save('Smy%s_TSMb_fcue.npy'%(pyID),fbest1) 


# In[11]:


#ftao
for i in range(len(sentest)):
    fprim=fprim0
    dvmax=dvmax0
    f_grain=f_grain0
    fbp=fbp0
    fba=fba0
    frate=frate0
    fage=fage0
    #----
    fnp=fnp0
    fclay=fclay0
    fsm=fsm0
    fcue=fcue0
    ftao=ftao0*(1+sentest[i])
    fbest=matrix_fun(xav1,xak1,xdesorp1,beta1,kba1,c11,c21,obs,f_grain)
    #print('analytical steady SOC:','\n',fbest) 
    fbest1[:,i]=matrix_funs(fprim,dvmax,f_grain,fbp,fba,frate,fage,fnp,fclay,fsm,fcue,ftao,obs,fbest,Tair,npp)
    #print(i,fbest1[:,i])
    print('ftao:',i)
np.save('Smy%s_TSMb_ftao.npy'%(pyID),fbest1) 


# ### plot

# In[2]:


fd=np.load('Smy04a_TSMb_fd.npy') 
fv=np.load('Smy04a_TSMb_fv.npy')
HI=np.load('Smy04a_TSMb_HI.npy')
fbp=np.load('Smy04a_TSMb_fbp.npy')
fba=np.load('Smy04a_TSMb_fba.npy')
frate=np.load('Smy04a_TSMb_frate.npy')
fage=np.load('Smy04a_TSMb_fage.npy')
#----
fnpp=np.load('Smy04a_TSMb_fnpp.npy')
fclay=np.load('Smy04a_TSMb_fclay.npy')
fsm=np.load('Smy04a_TSMb_fsm.npy')
fcue=np.load('Smy04a_TSMb_fcue.npy')
ftao=np.load('Smy04a_TSMb_ftao.npy')

print(fd.shape)
file=[fd,fv,fbp,fba,frate,fage]
ffile=[fnpp,fclay,fsm,fcue,ftao]


# In[3]:


import numpy as np  #
import seaborn as sns  
import seaborn
sns.set()#

fig=plt.figure(figsize=(9,6))
plt.subplots_adjust(left=0.15, bottom=0.15, right=0.95, top=0.95, wspace=0.2, hspace=0.)  
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})

title=['(a) $\mathregular{f_d}}$','(b) $\mathregular{f_v}}$','(c) $\mathregular{f_{bp}}$',
       '(d) $\mathregular{f_{ba}}$','(e) Rate_BC','(f) Age_BC']
for i in range(6):
    ax1 = fig.add_subplot(2,3,i+1)
    ax1.set_title(title[i], weight='bold', loc='left')
    plt.xlim(-5,50)
    plt.ylim(0,0.25)
    #seaborn.set_style(style='white')
    f=file[i]
    sns.kdeplot(f[:,0],shade=True,color="g",label='-50%')
    sns.kdeplot(f[:,1],shade=True,color="deepskyblue",label='-25%')
    sns.kdeplot(f[:,2],shade=True,color="grey",label='0%')
    sns.kdeplot(f[:,3],shade=True,color="pink",label='25%')
    sns.kdeplot(f[:,4],shade=True,color="plum",label='50%')
    fig.tight_layout()
    ax1.set_xlabel('Output parameter (g kg$\mathdefault{^{-1}}$)')
    ax1.set_ylabel('Density')
    ax1.axvline(np.nanmean(f[:,0]),ls='--', lw=0.5, c='g')
    ax1.axvline(np.nanmean(f[:,1]),ls='--', lw=0.5, c='deepskyblue') 
    ax1.axvline(np.nanmean(f[:,2]),ls='--', lw=0.5, c='grey') 
    ax1.axvline(np.nanmean(f[:,3]),ls='--', lw=0.5, c='pink') 
    ax1.axvline(np.nanmean(f[:,4]),ls='--', lw=0.5, c='plum') 

    plt.legend(loc='best',frameon=False)
#fig.savefig('fig%s_sentest.png'%(pyID),dpi=300)


# In[4]:


fig=plt.figure(figsize=(9,6))
plt.subplots_adjust(left=0.15, bottom=0.15, right=0.95, top=0.95, wspace=0.2, hspace=0.)  
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})

title=['(a) $\mathregular{f_{npp}}}$','(b) $\mathregular{f_{clay}}}$','(c) $\mathregular{f_{sm}}$',
       '(d) $\mathregular{f_{cue}}$','(e) $\mathregular{f_{tao}}$']
for i in range(5):
    ax1 = fig.add_subplot(2,3,i+1)
    ax1.set_title(title[i], weight='bold', loc='left')
    plt.xlim(-5,50)
    plt.ylim(0,0.25)
    #seaborn.set_style(style='white')
    f=ffile[i]
    sns.kdeplot(f[:,0],shade=True,color="g",label='-50%')
    sns.kdeplot(f[:,1],shade=True,color="deepskyblue",label='-25%')
    sns.kdeplot(f[:,2],shade=True,color="grey",label='0%')
    sns.kdeplot(f[:,3],shade=True,color="pink",label='25%')
    sns.kdeplot(f[:,4],shade=True,color="plum",label='50%')
    fig.tight_layout()
    ax1.set_xlabel('Output parameter (g kg$\mathdefault{^{-1}}$)')
    ax1.set_ylabel('Density')
    ax1.axvline(np.nanmean(f[:,0]),ls='--', lw=0.5, c='g')
    ax1.axvline(np.nanmean(f[:,1]),ls='--', lw=0.5, c='deepskyblue') 
    ax1.axvline(np.nanmean(f[:,2]),ls='--', lw=0.5, c='grey') 
    ax1.axvline(np.nanmean(f[:,3]),ls='--', lw=0.5, c='pink') 
    ax1.axvline(np.nanmean(f[:,4]),ls='--', lw=0.5, c='plum') 
    plt.legend(loc='best',frameon=False)
#fig.savefig('fig%s_sentest.png'%(pyID),dpi=300)    


# In[5]:


fd_chan=np.zeros(fd.shape)
fv_chan=np.zeros(fd.shape)
HI_chan=np.zeros(fd.shape)
fbp_chan=np.zeros(fd.shape)
fba_chan=np.zeros(fd.shape)
frate_chan=np.zeros(fd.shape)
fage_chan=np.zeros(fd.shape)

fnpp_chan=np.zeros(fd.shape)
fclay_chan=np.zeros(fd.shape)
fsm_chan=np.zeros(fd.shape)
fcue_chan=np.zeros(fd.shape)
ftao_chan=np.zeros(fd.shape)
for i in range(5):
    fd_chan[:,i]=(fd[:,i]-fd[:,2])/fd[:,2]*100
for i in range(5):
    fv_chan[:,i]=(fv[:,i]-fv[:,2])/fv[:,2]*100
for i in range(5):
    HI_chan[:,i]=(HI[:,i]-HI[:,2])/HI[:,2]*100
for i in range(5):
    fbp_chan[:,i]=(fbp[:,i]-fbp[:,2])/fbp[:,2]*100
for i in range(5):
    fba_chan[:,i]=(fba[:,i]-fba[:,2])/fba[:,2]*100
for i in range(5):
    frate_chan[:,i]=(frate[:,i]-frate[:,2])/frate[:,2]*100    
for i in range(5):
    fage_chan[:,i]=(fage[:,i]-fage[:,2])/fage[:,2]*100 
    fnpp_chan[:,i]=(fnpp[:,i]-fnpp[:,2])/fnpp[:,2]*100 
    fclay_chan[:,i]=(fclay[:,i]-fclay[:,2])/fclay[:,2]*100 
    fsm_chan[:,i]=(fsm[:,i]-fsm[:,2])/fsm[:,2]*100 
    fcue_chan[:,i]=(fcue[:,i]-fcue[:,2])/fcue[:,2]*100 
    ftao_chan[:,i]=(ftao[:,i]-ftao[:,2])/ftao[:,2]*100  
    
file1=[fd_chan,fv_chan,fbp_chan,fba_chan,frate_chan,fage_chan]
ffile1=[fnpp_chan,fclay_chan,fsm_chan,fcue_chan,ftao_chan]
file1[0].shape


# In[95]:


fig = plt.figure(figsize=[10,10]) 
plt.subplots_adjust(left=0.09, bottom=0.1, right=0.95, top=0.95, wspace=0.2, hspace=0.3) 
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})

label=['$\mathregular{f_d}}$','$\mathregular{f_v}}$','$\mathregular{f_{bp}}$',
       '$\mathregular{f_{ba}}$','Rate_BC','Age_BC']
title=['(a) $\mathregular{f_d}}$','(b) $\mathregular{f_v}}$','(c) $\mathregular{f_{bp}}$',
       '(d) $\mathregular{f_{ba}}$','(e) Rate_BC','(f) Age_BC','(g)']
bmlabels = ['-50%', '-25%', '0%', '25%','50%']
colors0 = ['g', 'brown', 'lime', 'dimgray', 'orange']
colors = ['white', 'white', 'white', 'white', 'white']
color1=['#1eafed','#ff9a00','#00bd56','#a5bdfd','#9862ae','#9e7e44']
for i in range(7):
    if i<6:
        ax = plt.subplot(3,3,i+1,facecolor='none')
        ax.set_title(title[i], weight='bold', loc='left')
        ax.axhline(y=0,ls='-', lw=0.5, c='k')
        ax.axvline(x=3,ls='-', lw=0.5, c='k')
        #ax.set_xlim(0,6)
        ax.set_ylim(-50,50)
        ax.set_xticks(np.arange(1,6))
        #ax.set_xticklabels([])
        #fig.tight_layout()
        if i>3:
            plt.xlabel('Change of input parameter/variable (%)')
        #ax.set_xticklabels(bmlabels[i])
        if i==3:
            #ax.set_ylabel('SOC changes with biochar addition (g kg$\mathdefault{^{-1}}$)',y=0)#, y=1)   
            plt.ylabel('Change of output ΔSOC (%)')
        #ax.set_xticklabels([])    
        f=np.array(file1[i])
        bplot= ax.boxplot(f,whis=[0,100],vert=True,patch_artist=True,meanline=True,showmeans=True,
                meanprops={'color': 'green', 'ls': '--', 'linewidth': 1.5},
                 medianprops={'color': 'orange', 'linewidth': 1.5})   

        plt.setp(bplot['boxes'], facecolor='none', edgecolor=colors0[0])
        plt.setp(bplot['whiskers'], color=colors0[0])
        #plt.setp(bp['medians'], color=colors[j])
        plt.setp(bplot['caps'], color=colors0[0])
        #reference:
        #plt.boxplot(np.array([A, B, C, D, E, F]),medianprops={'color': 'red', 'linewidth': '1.5'},meanline=True,showmeans=True,meanprops={'color': 'blue', 'ls': '--', 'linewidth': '1.5'},flierprops={"marker": "o", "markerfacecolor": "red", "markersize": 10})   
        for patch, color in zip(bplot['boxes'], colors):
            patch.set_facecolor(color)
    # add x-tick labels  
        plt.setp(ax, xticks=[y+1 for y in range(5)],xticklabels=bmlabels) 
    if i==6:
        ax = plt.subplot(3,3,i+1,facecolor='white')
        ax.set_title(title[i], weight='bold', loc='left')
        x=[-50,-25,0,25,50]
        x=np.arange(5)
        ax.set_xticks(np.arange(5))
        ax.set_xticklabels(bmlabels)
        ax.axhline(y=0,ls='-', lw=0.5, c='k')
        ax.axvline(x=2,ls='-', lw=0.5, c='k')
        plt.xlabel('Change of input parameter/variable (%)')
        #plt.ylabel('Change of output parameter (%)')
        for j in range(6):
            ax.plot(x,np.mean(file1[j],axis=0),label=label[j],color=color1[j],linewidth=1., markersize=5, marker='o')

        #ax.legend(frameon=False, loc=(0.5,0.), ncol=1, labelspacing=0.1)
        ax.legend(frameon=False, ncol=1, labelspacing=0.2, bbox_to_anchor=(1, 0.9))
    
fig.savefig('fig%s_sentest_box.png'%(pyID),dpi=300)    


# In[96]:


fig = plt.figure(figsize=[10,8]) 
plt.subplots_adjust(left=0.1, bottom=0.3, right=0.95, top=0.95, wspace=0.2, hspace=0.3) 
plt.rcParams.update({'font.size': 12})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})
fig.tight_layout()

label=['NPP','Clay','SM','MGE','${τ}$']

title=['(a) $\mathregular{f_{npp}}}$','(b) $\mathregular{f_{clay}}}$','(c) $\mathregular{f_{sm}}$',
       '(d) $\mathregular{f_{cue}}$','(e) $\mathregular{f_{tao}}$','(f) ']
title=['(a) NPP','(b) Clay','(c) SM','(d) MGE','(e) ${τ}$','(f)']

bmlabels = ['-50%', '-25%', '0%', '25%','50%']
colors0 = ['g', 'brown', 'lime', 'dimgray', 'orange']
colors = ['white', 'white', 'white', 'white', 'white']
color1=['#1eafed','#ff9a00','#00bd56','#207dff','#9862ae','#9e7e44']
for i in range(6):
    if i<5:
        ax = plt.subplot(2,3,i+1)
        ax.set_title(title[i], weight='bold', loc='left')
        ax.axhline(y=0,ls='-', lw=0.5, c='k')
        ax.axvline(x=3,ls='-', lw=0.5, c='k')
        #ax.set_xlim(0,6)
        ax.set_ylim(-60,60)
        ax.set_xticks(np.arange(1,6))
        #ax.set_xticklabels([])
        #fig.tight_layout()
        if i>2:
            plt.xlabel('Change of input parameter/variable (%)')
        #ax.set_xticklabels(bmlabels[i])
        if i==3:
            #ax.set_ylabel('SOC changes with biochar addition (g kg$\mathdefault{^{-1}}$)',y=0)#, y=1)   
            plt.ylabel('Change of output ΔSOC (%)',y=1)
        #ax.set_xticklabels([])    
        f=np.array(ffile1[i])
        bplot= ax.boxplot(f,whis=[0,100],vert=True,patch_artist=True,meanline=True,showmeans=True,
                          meanprops={'color': 'green', 'ls': '--', 'linewidth': 1.5},
                          medianprops={'color': 'orange', 'linewidth': 1.5})   # fill with color 
        plt.setp(bplot['boxes'], facecolor='none', edgecolor=colors0[0])
        plt.setp(bplot['whiskers'], color=colors0[0])
        #plt.setp(bp['medians'], color=colors[j])
        plt.setp(bplot['caps'], color=colors0[0])
        #reference:
        #plt.boxplot(np.array([A, B, C, D, E, F]),medianprops={'color': 'red', 'linewidth': '1.5'},meanline=True,showmeans=True,meanprops={'color': 'blue', 'ls': '--', 'linewidth': '1.5'},flierprops={"marker": "o", "markerfacecolor": "red", "markersize": 10})   
        for patch, color in zip(bplot['boxes'], colors):
            patch.set_facecolor(color)
    # add x-tick labels
    #plt.setp(ax, xticks=[y+1 for y in range(len(f))],xticklabels=['x1', 'x2', 'x3', 'x4','x5'])    
        plt.setp(ax, xticks=[y+1 for y in range(5)],xticklabels=bmlabels) 
    if i==5:
        ax = plt.subplot(2,3,i+1)
        ax.set_title(title[i], weight='bold', loc='left')
        x=[-50,-25,0,25,50]
        x=np.arange(5)
        ax.set_xticks(np.arange(5))
        ax.set_xticklabels(bmlabels)
        ax.axhline(y=0,ls='-', lw=0.5, c='k')
        ax.axvline(x=2,ls='-', lw=0.5, c='k')
        plt.xlabel('Change of input parameter/variable (%)')
        #plt.ylabel('Change of output parameter (%)')
        for j in range(5):
            ax.plot(x,np.mean(ffile1[j],axis=0),label=label[j],color=color1[j],linewidth=1., markersize=5, marker='o')

        #ax.legend(frameon=False, loc=(0.5,0.), ncol=1, labelspacing=0.1)
        ax.legend(frameon=False,ncol=2, labelspacing=0.2,bbox_to_anchor=(0.9, -0.3))# bbox_to_anchor=(1, 0.9)
    
fig.savefig('fig%s_sentest_box.png'%(pyID),dpi=300)    


# In[34]:


fig=plt.figure(figsize=(9,6))
plt.subplots_adjust(left=0.15, bottom=0.15, right=0.95, top=0.95, wspace=0.2, hspace=0.)  
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})
#seaborn.set_style(style=None)
#seaborn.set_style(rc={"lines.linewidth": 0.5})
seaborn.set_style("ticks", {"xtick.major.size": 8, "ytick.major.size": 8,}) #"ytick.color": 'k'

title=['(a) $\mathregular{f_d}}$','(b) $\mathregular{f_v}}$','(c) $\mathregular{f_{bp}}$',
       '(d) $\mathregular{f_{ba}}$','(e) Rate_BC','(f) Age_BC']
for i in range(6):
    ax1 = fig.add_subplot(2,3,i+1,facecolor='white')
    ax1.set_title(title[i], weight='bold', loc='left')
    plt.xlim(-60,60)
    #plt.ylim(0,0.15)
    #seaborn.set_style(style='white')
    f=file1[i]
    sns.kdeplot(f[:,0],shade=True,color="g",label='-50%')
    sns.kdeplot(f[:,1],shade=True,color="deepskyblue",label='-25%')
    sns.kdeplot(f[:,2],shade=True,color="grey",label='0%')
    sns.kdeplot(f[:,3],shade=True,color="pink",label='25%')
    sns.kdeplot(f[:,4],shade=True,color="plum",label='50%')
    fig.tight_layout()
    if i>2:
        ax1.set_xlabel('Change of output parameter (%)')
    ax1.set_ylabel('Density')
    ax1.axvline(np.nanmean(f[:,0]),ls='--', lw=0.5, c='g')
    ax1.axvline(np.nanmean(f[:,1]),ls='--', lw=0.5, c='deepskyblue') 
    ax1.axvline(np.nanmean(f[:,2]),ls='--', lw=0.5, c='grey') 
    ax1.axvline(np.nanmean(f[:,3]),ls='--', lw=0.5, c='pink') 
    ax1.axvline(np.nanmean(f[:,4]),ls='--', lw=0.5, c='plum') 
    plt.legend(loc='best',frameon=False)
#fig.savefig('fig%s_sentest.png'%(pyID),dpi=300)


# In[26]:


fig=plt.figure(figsize=(9,6))
plt.subplots_adjust(left=0.15, bottom=0.15, right=0.95, top=0.95, wspace=0.2, hspace=0.)  
plt.rcParams.update({'font.size': 13})
plt.rc('font',**{'family':'sans-serif','sans-serif':['Helvetica']})
plt.rc('font',**{'family':'Arial'})

title=['(a) $\mathregular{f_{npp}}}$','(b) $\mathregular{f_{clay}}}$','(c) $\mathregular{f_{sm}}$',
       '(d) $\mathregular{f_{cue}}$','(e) $\mathregular{f_{tao}}$']
for i in range(5):
    ax1 = fig.add_subplot(2,3,i+1)
    ax1.set_title(title[i], weight='bold', loc='left')
    plt.xlim(-80,80)
    plt.ylim(0,0.15)
    #seaborn.set_style(style='white')
    f=ffile1[i]
    sns.kdeplot(f[:,0],shade=True,color="g",label='-50%')
    sns.kdeplot(f[:,1],shade=True,color="deepskyblue",label='-25%')
    sns.kdeplot(f[:,2],shade=True,color="grey",label='0%')
    sns.kdeplot(f[:,3],shade=True,color="pink",label='25%')
    sns.kdeplot(f[:,4],shade=True,color="plum",label='50%')
    fig.tight_layout()
    if i>2:
        ax1.set_xlabel('Change of output parameter (%)')
    ax1.set_ylabel('Density')
    ax1.axvline(np.nanmean(f[:,0]),ls='--', lw=0.5, c='g')
    ax1.axvline(np.nanmean(f[:,1]),ls='--', lw=0.5, c='deepskyblue') 
    ax1.axvline(np.nanmean(f[:,2]),ls='--', lw=0.5, c='grey') 
    ax1.axvline(np.nanmean(f[:,3]),ls='--', lw=0.5, c='pink') 
    ax1.axvline(np.nanmean(f[:,4]),ls='--', lw=0.5, c='plum') 
    plt.legend(loc='best',frameon=False)
#fig.savefig('fig%s_sentest.png'%(pyID),dpi=300)




