# -*- coding: utf-8 -*-
'''
Copyright 2015 by Tobias Houska
This file is part of Statistical Parameter Estimation Tool (SPOTPY).

:author: Tobias Houska

This class holds example code how to use the dream algorithm
'''
#-----------------------0----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup0
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    
    # Initialize the Hymod example
    # In this case, we tell the setup which algorithm we want to use, so
    # we can use this exmaple for different algorithms
    spot_setup0=spot_setup0(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=0
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup0, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    #sampler=spotpy.algorithms.sceua(spot_setup)
    #Start the sampler, one can specify ngs, kstop, peps and pcento id desired
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    #sampler.sample(rep,ngs=10,kstop=10,peps=0.001,pcento=0.001)
    # Load the results gained with the sceua sampler, stored in SCEUA_hymod.csv
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
    
#-----------------------1----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup1
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup1=spot_setup1(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=1
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup1, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))

#-----------------------2----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup2
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup2=spot_setup2(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=2
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup2, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------3----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup3
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup3=spot_setup3(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=3
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup3, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------4----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup4
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup4=spot_setup4(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=4
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup4, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------5----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup5
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup5=spot_setup5(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=5
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup5, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------6---------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup6
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup6=spot_setup6(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=6
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup6, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------7----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup7
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup7=spot_setup7(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=7
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup7, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------8---------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup8
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup8=spot_setup8(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=8
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup8, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))
#-----------------------9----------------------------
import numpy as np
import spotpy
from spotpy.examples.spot_setup_mimics_python_vkd_HMJ_newversion_T_cv import spot_setup9
import matplotlib.pyplot as plt


if __name__ == "__main__":
    parallel ='seq' # Runs everthing in sequential mode
    np.random.seed(2000) # Makes the results reproduceable
    spot_setup9=spot_setup9(spotpy.objectivefunctions.rmse)
    
    #Select number of maximum allowed repetitions
    rep=5000
    ntime=9
    print('ntime:',ntime)
    sampler=spotpy.algorithms.sceua(spot_setup9, dbname='SCEUA_mimics_T%s'%(ntime), dbformat='csv')
    sampler.sample(rep, ngs=7,kstop=3,peps=0.1, pcento=0.1)
    results = spotpy.analyser.load_csv_results('SCEUA_mimics_T%s'%(ntime))

